liblouis NEWS -- history of user-visible changes.  	-*- org -*-

* Noteworthy changes in release 3.38.0 (2026-06-01)
This release is highlighted by a new Norwegian grade 3 contraction
table, the result of Lars Bjørndal's work implementing the revised
Braille Authority rules. The Swedish tables have been thoroughly
renewed and now also cover Sami and Elfdalian. Malayalam has been
updated to comply with the new Bharati Braille 2026 rules. Several
security vulnerabilities were fixed, and the documentation was
improved.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/48?closed=1][the list of closed
issues]].

** Bug fixes
- Fix several memory safety issues:
  - a heap-buffer-overflow in ~back_passDoAction~ thanks to Justin
    Stitt;
  - a null pointer dereference in ~pattern_compile_expression~, a
    buffer overflow in ~_lou_logWidecharBuf~, null pointer
    dereferences in ~_lou_compileTranslationRule~ and
    ~_lou_compileDisplayRule~, a segfault in ~lou_compileString~, and
    missing length validation in ~_lou_backTranslate~, all thanks to
    FuzzAnything.
** Braille table improvements
- Major renewal of Swedish 6- and 8-dot tables, now reorganized to
  share common data. New tables for Sami and Elfdalian are also
  included, thanks to InsynScandinavia.
- Updated Malayalam table with Bharati Braille 2026 rules, thanks to
  Jake Kyle.
- Improvements to Hungarian forward and backward translation thanks to
  Attila Hammer.
- Fix UK Grade 2 back-translation incorrectly expanding letter
  combinations such as ~bl~ and ~ac~ when they appear in the middle of
  a word, thanks to Kara Louise.
- Fix a long-standing typo with ~begnum mt~ in all 5 Danish Grade 2
  tables, thanks to Bue Vester-Andersen.
- Add a Norwegian table for Spanish text (~es-no.utb~), thanks to Bert
  Frees.
- Add a Norwegian grade 3 contraction table implementing the revised
  Braille Authority rules, along with missing grade 2 contractions and
  minor fixes, thanks to Lars Bjørndal and Hans Anton Ålien.
- Replace Estonian computer braille table ~et.ctb~ with the newer
  ~et-g0.utb~, thanks to Taniel Kirikal and Bert Frees.
** Other changes
- Updated documentation to clarify the differences between ~digit~,
  ~litdigit~ and ~numsign~ opcodes, thanks to Anthony Tibbs.
** Backwards incompatible changes
- The table compiler now rejects uppercase virtual dots (~A~..~F~);
  only the lowercase forms (~a~..~f~) are valid as documented.
** New, renamed or removed tables
*** New
- ~es-no.utb~
- ~ovd-6g0.utb~
- ~ovd-8g0.utb~
- ~smi-6g0.utb~
- ~smi-8g0.utb~
- ~sv-6common.uti~
- ~sv-6g0d.utb~
- ~sv-6g0p.utb~
- ~sv-6g1.uti~
- ~sv-6g1d.ctb~
- ~sv-6g2.uti~
- ~sv-6g2d.ctb~
- ~sv-8g0d.utb~
- ~sv-8g0n.utb~
- ~sv-8g1.uti~
- ~sv-8g1d.ctb~
- ~sv-8g1n.ctb~
- ~sv-8g2.uti~
- ~sv-8g2d.ctb~
- ~sv-8g2n.ctb~
- ~sv-phon.uti~

*** Renamed
- None

*** Removed
- ~et.ctb~
  - use ~et-g0.utb~ instead

* Noteworthy changes in release 3.37.0 (2026-03-02)
The nice thing about creating a release is that you get to bring in
all these wonderful contributions that people have provided. This
time we have new and improved braille tables for Danish, Devanagari,
English grade 3, Estonian 6-dot, Hungarian, Italian 6-dot, Norwegian
and UK 8-dot computer. Anthony has done incredible work to fix obscure
opcode bugs. XANOY and PGZXB have patched many security problems and
finally Benedict Carling has improved typeform handling for
back-translation so that it is finally usable.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/47?closed=1][the list of closed
issues]].

** New features
- The typeform buffer is now populated during back-translation. This
  allows applications to detect emphasis (italic, bold, underline)
  when translating braille back to text. Thanks to Benedict Carling of
  Paige Braille.
- The YAML test format has a new ~expected_typeform~ field to test
  that emphasis in braille is correctly detected during
  back-translation.
** Bug fixes
- Both ~sufword~ and ~prfword~ now correctly recognize ~seqdelimiter~
  characters as word boundaries during forward translation and respect
  ~nocontractsign~ during back-translation, thanks to Anthony Tibbs.
- Fix contraction opcode bugs when using ~nocontractsign~ thanks to
  Anthony Tibbs.
- Fix a NULL pointer dereference ~lou_readCharFromFile~ thanks to
  XANOY.
- Fix a memory leak in ~parseLanguageTag~ when parsing invalid queries
  and a heap buffer overflow in ~syllableBreak~. Both thanks to PGZXB.
- Fix a stack overflow when an invalid ~LOUIS_LOGLEVEL~ string is
  provided and avoid a crash when the table resolver is NULL. Both
  thanks to Anthony Tibbs.
- Fix an infinite loop in ~isEmphasizable~ caused if characters
  mistakenly reference one another thanks to Anthony Tibbs.
- Fix ~capsword~ translation with ~endword~ apostrophe'd letters (e.g.
  AA's, FBI's) again thanks to Anthony Tibbs.
- Fix a heap buffer overflow in ~translateString~ when handling
  ~joinnum~ or ~joinword~ rules. Thanks to Christian Egli for fixing
  and zerojackyi for reporting it.
- Various code cleanups thanks to Bert Frees.
- Fix a stack buffer overflow in ~pattern_compile_expression~ and a
  stack buffer overflow in ~_lou_getTablePath~ when ~LOUIS_TABLEPATH~
  is too long, both thanks to PGZXB.
** Braille table improvements
- Add a complete implementation for UK 8-dot computer braille
  according to the standard created by the BAUK (Braille Authority of
  the UK) and currently maintained by the successor organization,
  UKAAF thanks to Seeing Hands.
- Vastly improved Italian 6-dot braille table thanks to Tommaso Nonis
  of Vision Dept S.r.l.
  - The table has been completely redesigned, and various mathematical
    symbols, capitalization and punctuation were fixed.
  - inputting characters from A to J no longer results in numbers being
    inserted instead.
  - Parentheses, quotation marks, brackets and braces now display correctly
  - Emphasis marks have been introduced for bold, italic and
    underline, allowing these to be viewed in screen reader utilities
    that support them.
- Improvements to Norwegian thanks to Lars Bjørndal.
- Corrections to Danish Grade 2 thanks to Bue Vester-Andersen.
- Improvements to Hungarian forward and backward translation thanks to
  Attila Hammer.
- Major updates to Devanagari to comply with the new Bharti Braille
  rules 2.1. Also support for back-translation support was added
  thanks to Dipendra Manocha and Jake Kyle.
- Add an Estonian 6-dot braille table based on the official Estonian
  Braille Standard (March 2009) and Eesti punktkirja käsiraamat (2011)
  thanks to Artur Räpp and Taniel Kirikal.
- Improvements to English grade 3 thanks to Bue Vester-Andersen.
** Other changes
- None
** Deprecation notice
- None
** Backwards incompatible changes
- The ~literal~ opcode has been removed as it was synonymous with the
  ~compbrl~ opcode. 
** Invisible changes
- None
** New, renamed or removed tables
*** New
- et-6dot.utb

*** Renamed
- None

*** Removed
- it.tbl
  - use it-it-comp6.utb instead

* Noteworthy changes in release 3.36.0 (2025-12-01)
This release brings various updates to braille tables, particularly
for Slovakian and Norwegian in line with the respective changes to
their the braille standards. There are new tables for Macedonian
uncontracted braille and the long awaited table for English Grade 3 is
finally here. On the technical side, there are modernized Python
bindings and better support for building liblouis for environments
such as Android.

I'd like to thank everyone for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/46?closed=1][the list of closed
issues]].

** New features
- There is a new table for Macedonian uncontracted braille thanks to
  Kristijan Lazarev.
- There is a new table for [[http://www.grade3braille.com][English Grade 3]] thanks to Bue
  Vester-Andersen.
** Bug fixes
- Fix a bug with having to double escape certain characters in match
  patterns. Escaping now works as you'd expect thanks to Christian
  Egli.
** Braille table improvements
- Improvements to Hungarian forward and backward translation thanks to
  Attila Hammer.
- Update the Slovakian 6-dot literary table to be in line with the
  latest Slovak braille standards thanks to Peter Vágner and other
  members of the [[https://www.skn.sk/en/the-braille-authority-of-slovakia][Braille Authority of Slovakia]].
  - Added emphasis indication for bold, italic and underline
  - Fixed back translation issues
  - Added additional symbols for foreign Latin alphabet characters
- Norwegian Grade 2 has seen a major overhaul according to the
  adjustments made by the Norwegian Braille Authority thanks to Lars
  Bjørndal.
- Improve the handling of Greek letters in Norwegian 8-dot braille
  thanks to Lars Bjørndal.
** Other changes
- Fix the linking of the fuzzers thanks to Samuel Thibault.
- Use ~"config.h"~ instead of ~<config.h>~ for portability thanks to
  Patryk Miś. This change does not affect normal autotools builds, but
  improves portability for alternative build systems such as CMake,
  Bazel, or the Android NDK.
- Modernize the Python bindings thanks to Leonard de Ruijter. The
  minimum Python version is now 3.10. The syntax has been updated,
  type hints have been added and the doc strings are modernized.
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- ~mk-g1.utb~
- ~en-g3.ctb~

*** Renamed
- None

*** Removed
- None

* Noteworthy changes in release 3.35.0 (2025-09-01)
This release brings quite a few technical improvements. We've enhanced
support for memory management in the API, added support for math
characters in ~match~ rules, expanded the Python bindings to include
metadata API support, and made it possible to set the log level via
the ~LOUIS_LOGLEVEL~ environment variable.

There are also substantial updates to various language tables,
including improvements to Portuguese 8-dot braille, Hebrew
back-translation, Norwegian 8-dot support, UEB forward translation,
and Hungarian braille. We've added support for Rokuten Kanji (Japanese
Kanji Braille). Russian, Ukrainian, and Belarusian literary braille
tables have received updates to their space handling rules, and the
Danish tables have seen fixes related to typos and hyphenation.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/45?closed=1][the list of closed
issues]].

** New features
- ~match~ rules now also support testing for math characters. Thanks
  to James Bowden for the idea and Bert Frees for the implementation.
- Add Support for "Rokuten Kanji", the other Japanese system for Kanji
  Braille.
- The API now contains functions to free memory that was returned by
  API calls. See the documentation for details. Thanks to Leonard de
  Ruijter.
- The Python bindings now support most of the metadata API, thanks to
  Leonard de Ruijter.
** Bug fixes
- ~ucBrl~ in the mode parameter now correctly works also for
  back-translation. Thanks to Bert Frees.
- Fix a segfault when a StringBuffer is used before it is initialized.
  Thanks to Anthony Tibbs.
- Fix a bug in the handling of ~nocont~ in conjunction with
  ~seqdelimiter~. Thanks to Bert Frees.
** Braille table improvements
- Improvements to the Portuguese 8-dot Braille table: Correct angle
  quotation mark characters used in Portugal, add missing symbols,
  such as Greek alphabet and double quotation mark characters used in
  Brazil. Also added symbols that aren't defined in the Portuguese
  standard but are commonly found in texts and web pages, such as
  bullet points, some common mathematical symbols, etc. Thanks to
  Tiago M. Casal.
- Fix the back-translation of the Greek Sigma and other small
  improvements to the Hebrew table. Thanks to Leonard de Ruijter.
- Improvements to Norwegian 8dot thanks to Lars Bjørndal.
  - Add more characters and math symbols.
  - Fix a back-translation problem when two dot 6 are followed by a
    word.
  - Fix a problem where the letter "i" is immediately followed by
    number.
- Improvements to UEB forward translation, in particular fixes for
  rarer words and some proper names. Thanks to James Bowden.
- Hungarian improvements thanks to Attila Hammer.
- Fix typos and hyphenations in the Danish tables thanks to Bue
  Vester-Andersen.
- Improvements to the back translation for the Russian literary
  Braille table: Now, if a space is intentionally input after a comma
  or semicolon, a double space will not occur. If no space was input,
  a space will still be automatically added, as before. This change
  also applies to Ukrainian and Belarusian literary Braille tables.
  Thanks to Andrey Yakuboy.
** Other changes
- Hans Anton Ålien proof read the documentation and fixed quite a few
  typos.
- The log level of the library can now also be set via the
  ~LOUIS_LOGLEVEL~ environment variable.
** Deprecation notice
- None
** Backwards incompatible changes
** Invisible changes
** New, renamed or removed tables
*** New
- ja-rokutenkanji.utb

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.34.0 (2025-06-05)
This release brings significant improvements to various language
tables, particularly for Classical/Biblical Hebrew where three main
standards are now supported. We have a new table for Thai Grade 2
contracted braille, and substantial updates to Lithuanian braille
tables. There are also improvements to Hungarian, Dutch, Norwegian,
and Turkish tables. On the technical side, there's new support for
building macOS universal binaries and the pre-built html and plain
text documentation is no longer packaged with the released tarball.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/44?closed=1][the list of closed
issues]].

** New features
- A new table for Thai Braille Grade 2, a contracted Braille system,
  has been added thanks to Chatupol Nootatong.
** Braille table improvements
- Hungarian improvements thanks to Attila Hammer.
- Fix a bug in the Dutch table related to apostrophes after a number
  which are not always a minute sign. Thanks to Bert Frees.
- Fix the metadata of the Russian 6-dot computer braille table thanks
  to Bert Frees and Andrey Yakuboy.
- Minor improvements to the Norwegian Braille: Some small fixes
  regarding 6 dot, added Cyrillic alphabet and added certain new
  characters to 8 dot, including bullet points used by JAWS when using
  Liblouis for 8 dot. Thanks to Lars Bjørndal and Bert Frees.
- Major changes to the Lithuanian braille tables thanks to Rimas
  Kudelis
  - Renamed ~lt.ctb~ to ~lt-8dot.utb~
  - Both tables have been reviewed and modified.
    - The 6-dot table is now closer to the national standard issued
      in 2019.
    - The 8-dot table is now intended to align with the 6-dot table
      instead of the 8-dot standard from 2011.
    - Some whitespaces in the table files have been eliminated to make
      them easier to read using braille terminals.
- Fixes for back-translation issues involving subscript numerals,
  diacritic marks, and capital letters turning into Greek letters.
  Makes no changes to the UEB-style cuneiform transliteration table.
  Thanks to Eric Harvey.
- Major Expansion and Improvements to Classical/Biblical Hebrew thanks
  to Eric Harvey.
  - Two new translation tables have been added so that the three main
    standards for Classical Hebrew are now available:
    1. The original International Hebrew Braille Code (~hbo.utb~)
    2. The system for full cantillation developed by Ray McAllister,
       Matthew Yeater, and Sarah Blake LaRose (~hbo-cantillated.utb~)
    3. The compact standard without dagesh or shewa represented in the
       Katz transcription manual (~hbo-slim.utb~)
  - ~hbo.utb~ is now the table for the International Hebrew Braille
    Code. Before it was used for the IHBC-McCallister system (now
    ~hbo-cantillated.utb~). The International Hebrew Braille Code is
    the most-established and widely used standard for Classical
    Hebrew, so it seems right to make it the basic table.
  - Most of the Hebrew-specific rules are contained in ~.uti~ files,
    and the ~.utb~ files only add rules for uncontracted English
    support. Since Classical Hebrew readers usually have another first
    language, this allows non-English speakers to create custom
    translation tables with Hebrew and their first language, or for
    easier inclusion in multilingual tables like
    ~ancient-languages-us.utb~.
  - In addition to the new tables, there are improvements to the
    ~hbo-cantillated.utb~ table for consistency and to make sure that
    braille output matches that produced by Duxbury as closely as
    possible:
    - Ultra long vowels now contract consistently.
    - Cantillation marks no longer interrupt the contractions for
      ultra-long vowels (hiriq-yod and tsere-yod).
    - Holam now always renders properly as 135 and holam waw as 246.
- Improvements to Turkish grade 1 and Turkish computer braille,
  thanks to Oğuz Uğur and Ozancan Karataş
** Other changes
- There is a new configure option to build macOS universal binaries
  thanks to Bert Frees.
- Fix incorrect (non-https) link in the documentation thanks to
  jinwoolee.
- The pre-built html and plain text documentation is no longer
  packaged with the released tarball. All formats of the documentation
  can still be built from the source and from the released tarball as
  explained in the README. Thanks to Christian Egli.
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- hbo-cantillated.utb (formerly hbo.utb - hbo.utb was changed to follow the IHBC)
- hbo-slim.utb
- th-g2.ctb
- lt-8dot.utb

*** Renamed
- ru-compbrl.ctb -> ru-comp6.utb
- ru.ctb -> ru-comp8.utb

*** Removed
None

* Noteworthy changes in release 3.33.0 (2025-03-03)
This release combines braille improvements with security enhancements.
We have new tables for Coptic braille, Cuneiform transliteration and
for Portuguese 6-dot computer braille. There are improvements to
Dutch, Hungarian, the International Phonetic Alphabet, Norwegian and
UEB. On the security side a lot of people have reported and fixed
buffer overflows and other memory issues.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/43?closed=1][the list of closed
issues]].

** New features
- None
** Bug fixes
- A large number of buffer overflow problems have been solved:
  - Fix free error in ~parseQuery~ and ~analyzeTable~ thanks to Liu
    Yuwei
  - Fix an overflow in ~passDoAction~ and ~doPassSearch~ thanks to Liu
    Yuwei
  - Fixed a segfault in ~finalizeCharacter~ thanks to Christian Egli
    and cx104906.
  - Fix a heap-buffer-overflow error in ~compileRule~ and
    ~_lou_extParseChars~ thanks to tyler92.
  - Fix a heap buffer overflow in ~back_passDoAction~ thanks to Bert
    Frees and Liu Yuwei.
- A doc string has been added to ~lou_translateString~ and
  ~lou_translate~ outlining the buffer overflow risk thanks to
  Christian Egli and shuangxiangkan.
- Fix the default table search path on Windows thanks to Bert Frees
  and Bue Vester-Andersen
** Braille table improvements
- Fix the back-translation of capital sign in Dutch thanks to Bert Frees
- Major improvements to Norwegian thanks to Lars Bjørndal
- Improvements to the UEB table thanks to James Bowden. In particular
  the handling of words containing "somer", e.g. "Somerville" was
  fixed.
- Hungarian improvements (added more exceptions) thanks to Attila
  Hammer.
- Add a new 6-dot table for literary Coptic braille, thanks to Eric
  Harvey.
- Added some missing symbols (including space) to the table for the
  International Phonetic Alphabet, thanks to Robert Englebretson and
  James Bowden.
- Add a table for Portuguese 6-dot computer braille, thanks to Tiago
  M. Casal and Iván Argote-Pérez. The table is based on the official
  [[https://www.gov.br/mec/pt-br/media/publicacoes/semesp/grafiainfo.pdf][documentation in Portuguese]].
- Add a new table for Cuneiform transliteration. It differs from the
  existing table ~cuneiform-transliterated.utb~ in that it does not
  adopt UEB dot patterns for the various diacritic marks. Instead it
  uses bespoke diacritics inspired by some IPA symbols. Thanks to Eric
  Harvey.
** Other changes
- None
** Deprecation notice
- None
** Backwards incompatible changes
- Make value in table metadata field mandatory: It makes the metadata
  system clearer and simpler. Empty values have not been used anyway.
** Invisible changes
** New, renamed or removed tables
*** New
- ~cop.utb~
- ~cuneiform-transliterated-compact.utb~
- ~pt-comp6.utb~

*** Renamed
- None

*** Removed
- None

* Noteworthy changes in release 3.32.0 (2024-12-02)
A lot of intense work by Matt, Paul, Leonard, Eric, Sarah and Bert
went into this release. There are new tables for Biblical Language and
Ancient Near Eastern Studies. We have improvements for UEB, Spanish,
Turkish and Hungarian. There are also a couple of new features, for
example the handling of the language metadata has been extended to
handle language ranges.

I'd like to thank all the very dedicated contributors for helping to
push liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/42?closed=1][the list of closed
issues]].

** New features
- ~lou_translate~ now has an option to specify a display table. This
  is especially useful when using a query. Before it would just
  default to a Unicode display table, thanks to Christian Egli.
- Meta data for ~language~ and ~region~ can now be specified using a
  [[https://datatracker.ietf.org/doc/html/rfc4647#section-2.2][IETF Extended Language Range]]. This is particularly useful for
  accessing tables related to a specific region, for instance. Thanks
  to Bert Frees.

** Bug fixes
- Fix a memory problem in the ~getTable~ function. Thanks to the
  oss-fuzz project for reporting and to Christian Egli for fixing it.
- Fix a build problem on Windows related to ~strncasecmp~ which was
  reported at the last minute by Leonard de Ruijter and fixed by
  Christian Egli.

** Braille table improvements
- Updates to Spanish grade 1 thanks to José Manuel Delicado:
  - Removed lowered digits. This allows certain punctuation to be written again.
  - Included ~digits6Dots.uti~. This prevents the numsign from disappearing.
  - The symbols =.= and =,= are used as numeric mode chars.
  - Added the ~noback~ operator to the apostrophe symbol, since it's
    not very used and conflicts with the =.=.
- Extensive fixes to the UEB computer code thanks to James Bowden.
- Improvements to Turkish grade 2 thanks to Oğuz Uğur and Attila
  Hammer.
- Hungarian improvements (added more exceptions) thanks to Attila
  Hammer.
- There is now an include table for symbols referencing the critical
  apparatus in critical texts thanks to Matt Yeater.

** Other changes
- Migrate to ~realloc-posix~ from gnulib, as ~realloc-gnu~ that we
  used before is now deprecated. Thanks to Christian Egli.
- Improvements to the manual thanks to Huan Wu.
- Thanks to Rob Beezer we now have instructions on how to install
  Python bindings in a virtual environment.

** Deprecation notice
- None

** Backwards incompatible changes
- If liblouis has been compiled for 16-bit Unicode it will now error
  if a table contains characters outside of that range. Previously it
  would issue a warning and ignore the problem. Thanks to Christian
  Egli.

** Invisible changes
- None

** New, renamed or removed tables
*** New
- ~critical-apparatus.uti~
- ~he-common-consonants.uti~
- ~he-common-vowels-ihbc.uti~

*** Renamed
- None

*** Removed
- None

* Noteworthy changes in release 3.31.0 (2024-09-02)
This release adds support for new braille tables, such as Thai
contracted and Greek International US, and updates existing braille
tables such as the Finnish table which has been updated to the latest
braille standard. Benehalo has uncovered a number of security problems
in the liblouis code and has thankfully also provided fixes for them
by hardening the code.

I'd like to thank all the very dedicated contributors for helping to
push liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/41?closed=1][the list of closed
issues]].

** New features
- None
** Bug fixes
- Benehalo discovered quite a number of security problems and kindly
  enough also just fixed them by adding some check guards and making
  the code more robust.
** Braille table improvements
- Hungarian improvements (added more exceptions) thanks to Attila
  Hammer.
- The usage of ~match~ opcodes with empty pre- and post patterns, e.g.
  ~match - disk - 145-24-16~ in some tables has been replaced with
  plain old ~always~ opcodes, as their implementation is much faster.
- A change to the Spanish back-translation that went into the last
  release was reverted as it caused more problems than it solved.
- The Dutch display table has been improved thanks to Bert Frees.
- The Finnish table has been updated to reflect the latest Finnish
  braille standard from 2021 (Pistekirjoituksen perusteet, 2021)
  thanks to Sami Maatta from Celia.
- Added a new Thai contracted braille table according to the
  guidelines of "Thai Braille Use Manual" of the National Braille
  Promotion and Development Fund. Thanks to Chatupol Nootatong.
- Add a table for Greek International US braille. This table is based
  on the composed Greek characters, unlike the existing English
  table which is based on the decomposed system. Thanks to Sarah Blake
  LaRose and Leonard de Ruijter.

** Other changes
- None
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- ~th-g1.utb~
- ~grc-international-en-composed.utb~

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.30.0 (2024-06-03)
We are very excited to present this release, as a lot of enthusiasm
and energy have gone into it. A host of of new contributors have
improved liblouis and added support for new languages. We now have
support for many ancient languages, like Akkadian, Ugaritic, Biblical
Hebrew and Syriac. This release also supports Yiddish. And the Dutch
tables got a very innovative upgrade.

I'd like to thank all the very dedicated contributors for helping to
bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/40?closed=1][the list of closed
issues]].

** New features
- There is a new uncontracted braille table for Yiddish, created by
  Abby Howell and Matthew Shifrin, a teacher and student of Yiddish at
  the Boston Worker's Circle.
- A group of incredibly dedicated people has been working on support
  for ancient languages, namely Matt Yeater and Paul Geoghegan with
  the help of Sarah Blake LaRose, Eric Harvey, Leonard de Ruijter and
  Abby Howell. The languages that are supported so far are:
  - Biblical Hebrew
  - Akkadian according to Borger system
  - Akkadian braille according to U.S. system
  - Syriac
  - Ugaritic
  - A table to provide support for the languages represented in the
    Cuneiform / Akkadian Writing systems
** Bug fixes
- Fix a bug in the Python bindings that occurs on bigendian
  architectures, thanks to Daniel Garcia.
- Fix a memory problem when handling parameters in ~lou_translate~,
  thanks to benehalo.
** Braille table improvements
- Minor improvements to the Danish tables thanks to Bue Vester-Andersen:
  - Fixed a missing contraction for "gjorde".
- Improvements to Hungarian (added more exceptions) thanks to Attila
  Hammer.
- Corrections to the Malay Table thanks to lbk2907.
- Major improvements to Serbian backtranslation thanks to Aleksandar
  Sredojevic:
  - Backtranslation now works to both Cyrillic and Latin script.
- Fix the metadata for the Cantonese (Hong Kong) table thanks to André
  Polykanine.
- Improvements to backtranslation of Spanish grade 2 thanks to Iván
  Argote Pérez with the help of Abby Howell.
- Major upgrade to the Dutch tables thanks to Bert Frees. These tables
  use virtual dots in an innovative way to help sighted readers better
  understand the generated braille. They also use a new technique
  using ~m4~ macros to simplify writing tables that use many
  repetitive opcodes.
** Other changes
- The metadata now has support for ~unicode-range~, i.e. whether the
  characters used in a table all fall inside the ~0-U+FFFF~ Unicode
  range (~ucs2~), or whether some characters are in the >
  ~U+10000-U+10FFFF~ range (~ucs4~), thanks to Bert Frees.
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- ~sr-Cyrl.ctb~
- ~yi.utb~
- ~hbo.utb~
- ~akk.utb~
- ~akk-borger.utb~
- ~syc.utb~
- ~uga.utb~
- ~cuneiform-transliterated.utb~

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.29.0 (2024-03-04)
A lot of hard work by Andrey, Anthony, Attila, Bert, Bue and James
went into this release. We have many improvements for UEB, better
support for Belarusian and Ukrainian literary braille, a major upgrade
for Turkish and miscellaneous enhancements for Kannada, Danish, Dutch,
Esperanto and Malay. There is also a brand new table for classical
Greek for Spanish braille readers.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/39?closed=1][the list of closed
issues]].

** New features
- There is a new uncontracted braille for Lao thanks to Aikeo
  Koomanivong, disability service center in Lao PDR DSC.
- There is a new uncontracted braille table to read classical Greek
  characters according to the technical document B12-1 by the Spanish
  Braille Commission, thanks to Iván Novegil.
** Bug fixes
- None
** Braille table improvements
- Fixed issues with Kannada table ~kannada.cti~ thanks to Jake Kyle.
- Improvements to the Belarusian and Ukrainian literary braille tables
  thanks to Andrey Yakuboy:
  - Added support for back translation to the Belarusian and Ukrainian
    literary Braille tables (~bel.utb~ and ~uk.utb~ respectively).
  - Changed the dot patterns for parentheses in the Ukrainian braille table
    from 126-345 to 2356.
  - Added new tables for Belarusian and Ukrainian braille with indication of
    capital letters (~bel-detailed.utb~ and ~uk-detailed.utb~ respectively).
- Minor improvements to the Danish tables thanks to Bue Vester-Andersen:
  - Fixed definition of dollar sign ($)
  - Fixed rules for applying section sign (§)
  - Fixed contraction of some words
- Updates to UEB Contracted thanks to Anthony Tibbs:
  - Final letter groupsigns will not be used immediately following
    capital indicators (e.g. when the first letter of the groupsign is
    capitalized, or the groupsign follows a capitalized passage) per
    UEB Rule 10.8.2
- Updates to UEB thanks to James Bowden:
  - Back translating braille dot 3 now results in the ordinary
    apostrophe U+0027 rather than U+2019
  - Dot 5, used for "spaced digits" is only applied if a no-break
    space U+00a0 is used in the input. It fixes an issue with British
    postcodes which should be treated as two separate items. It also
    means that if someone wants spaced digits, numbers have to be
    joined together with no-break spaces deliberately.
- Do not collapse Unicode braille in Dutch, thanks to Davy Kager.
- Improvements to Hungarian (added more exceptions) thanks to Attila
  Hammer.
- Added support for back-translation to the Esperanto table, thanks
  to Bue Vester-Andersen.
- Major upgrade to the Turkish tables thanks to Oğuz UĞUR with lots of
  help from Attila Hammer.
  - add support for accented characters
  - add punctuation symbols from the Turkish Braille Writing Guideline
  - fix some contractions
- Corrections to the Malay Table thanks to lbk2907.
** Other changes
- Duplicate emphasis classes are no longer warnings thanks to
  Christian Egli. There are cases where emphasis redefinition is
  legitimate. They are simply logged now.
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- bel-detailed.utb
- uk-detailed.utb
- lo-g1.utb

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.28.0 (2023-12-04)
This release manages to bring as many new features, table improvements
and bug fixes as we haven't seen in a long time. There are a number of
major bug fixes that Bert worked on that fix bugs and inconsistencies.
On the table side there is a new table for Filipino contracted
braille, James has tirelessly been working on UEB improvements and (as
usual) Attila worked on the Hungarian tables.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/38?closed=1][the list of closed
issues]].

** New features
- ~lou_translate~ has a new option to specify the table to use with a
  query. See the updated documentation on how to make use of this new
  feature.
** Bug fixes
- Fix a bug when matching context rules that begin with uppercase
  letters. Thanks to Anthony Tibbs for the [[https://github.com/liblouis/liblouis/issues/1461][very detailed bug report]]
  and thanks to Bert for the actual fix.
- Fix a memory corruption error in the code for the swap opcodes.
  Thanks to the OSS-fuzz project for reporting and to Christian Egli
  for fixing it.
- Change how emphasis phrases are determined. Also allow non-whole
  words at the start and end of a phrase. This fixes a problem in the
  UEB handling. Thanks to Ken Perry from APH for reporting and to Bert
  Frees for fixing it.
- Character definition and base rules are now always considered in the
  order in which they are defined in the table. In other words the
  topmost rule always wins. This fixes a number of problems and
  inconsistencies. Thanks to Bert Frees for the fix.
  - Fix the problem of inconsistent precedence of character definition
    rules reported by Rimas Kudelis.
  - Fix a problem with ~compbrlAtCursor~ and ~compbrlLeftCursor~ that
    was reported by Daniel Mayr
** Braille table improvements
- Improvements to UEB
  - fixes to many words starting with letters "BE-".
  - Fix back translation of dots 26 - when standing alone; should be
    the word enough.
  - Fix assignment for the right double arrow and added left, up, and
    down double arrows.
  - Fix typos in a couple of rules.
  - Fix words beginning "CONS-" and "DISHD-" when written uppercase,
    all above thanks to James Bowden.
  - Ensure letter indicators are added to letters A-J following
    numbers in a capitalized passage, thanks to Anthony Tibbs.
- Improvements to Hungarian (added more exceptions) thanks to Attila
  Hammer.
- New table for Filipino contracted braille, thanks to Allan Mesoga
  and Dang Hoai Phúc.
** Other changes
- The ~manywarnigs~ module from gnulib is no longer used. It caused
  massive slowdowns when compiling with gcc.
- Add the name of the concerned table when logging warnings thanks to
  Bert Frees for the patch and to Attila Hammer for the PR.
** Deprecation notice
- None
** Backwards incompatible changes
- The order of how character definition and base rules are considered
  has changed. All included tables were adapted, but if you maintain
  your own tables you might want to look [[https://github.com/liblouis/liblouis/pull/1481][at the change]] to see what you
  need to do.
** Invisible changes
** New, renamed or removed tables
*** New
- fil-g2.ctb

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.27.0 (2023-09-12)
This release contains support for two more languages, namely Thai and
Romanian uncontracted braille. There is also the usual assortment of
incremental improvements to Bengali, Danish, Hungarian, Swedish, Urdu
and US English. To top it off, some great new contributors did some
code cleanups and bug fixes.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/37?closed=1][the list of closed
issues]].

** New features
- Added support for Thai braille thanks to Chatupol Nootatong, Dr.
  Wiraman Niyomphol and Itsawat Banlawanich from Thai braille fund and
  Foundation for the Blind in Thailand.
- Added a new Romanian 6 dot table, thanks to BAUM Engineering.
** Braille table improvements
- Update to Urdu, removing old rule where dots 256 was used for Urdu
  letters TEH ALEF. Thanks to Jake Kyle.
- Added the dari character to Bengali thanks to Attila Hammer.
- Improvements to Hungarian (added more exceptions) thanks to Attila
  Hammer.
- Improvements to Hungarian to support users if typing physical
  braille display, thanks to Attila Hammer.
- Fixed the translation of Unicode ellipses in US English grade 1 and
  2 tables thanks to Anthony Tibbs.
- Added some more symbols to the Nemeth character definitions thanks
  to Norbert Markus and Attila Hammer.
- Fixed a bug in Danish when back-translating a word contraction
  followed by "!", thanks to Bue Vester-Andersen.
- Improved handling of numbers and fixed a couple of whole-word
  contraction errors in Swedish braille thanks to Insyn Scandinavia
  AB.
- Added the possibility to retain the virtual dots on Dutch braille,
  so that it should be possible to distinguish between identical dot
  patterns that originate from different input. Thanks to Bert Frees.
** Other changes
- Removed some code smell thanks to Aaron Cannon.
- Duplicate emphasis class definitions now cause a warning, thanks to
  Attila Hammer.
** Deprecation notice
- None
** Backwards incompatible changes
- The line continuation feature was removed, as it was no longer
  needed and caused problems (e.g. [[https://github.com/liblouis/liblouis/issues/239][issue 239]]). The tables that
  depended on it were updated. Thanks to Aaron Cannon.
- Invalid attribute names now cause a table compilation error instead
  of just a warning. Thanks to Attila Hammer.
** New, renamed or removed tables
*** New
None

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.26.0 (2023-06-05)
This release contains one new feature, namely the possibility to mark
a test as an expected failure just for back- or forward translation.
On top of that we have updates for Danish, Hungarian, Norwegian and
Nemeth Braille plus the usual assortment of code cleanups and bug
fixes.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/36?closed=1][the list of closed
issues]].

** New features
- The YAML syntax to define tests has been improved so that expected
  failures can now contain a direction attribute. In other words you
  can now specify whether you expect a test to fail for both
  directions or just for forward or backward translation. For more
  details consult the updated documentation on how to write YAML
  tests. Thanks to Christian Egli.
** Bug fixes
- Fix an out-of-bound write in ~brl_checks.c~ thanks to Bert Frees for
  the fix and to Han Zheng for the report.
- Clear the display table cache on ~lou_free~ thanks to Bert Frees for
  the fix and to David Korczynski for the report.
** Braille table improvements
- Improvements to Hungarian (added more exceptions) thanks to Attila
  Hammer.
- Changed the Danish grade 2 tables in accordance with updates from
  the Danish Braille committee, thanks to thanks to Bue
  Vester-Andersen.
- Added support for more symbols in the Nemeth braille tables thanks to
  Norbert Markus.
- Improvements to Norwegian braille thanks to Lars Bjørndal
  - Put ~noback~ before acute sign to enable input at sign (email
    addresses).
  - Added more ~noback~ prefixes.
  - Corrected leftwards arrow and added definition for left right arrow.
  - Changed bullet point from 2356 to 36-36. According to the
    Norwegian braille standard, this is the preferred unordered list
    item prefix.
** Other changes
- Clarify the ~README~ for Python thanks to Rob Beezer.
- Properly remove support for Python2 in the Python bindings again
  thanks to Rob Beezer.
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- None

*** Renamed
- None

*** Removed
- None

* Noteworthy changes in release 3.25.0 (2023-03-06)
We dedicate this release to the memory of John Boyer, the original
author of liblouis. Sadly he passed away recently. We owe him a
tremendous amount of gratitude. Without him liblouis would not exist.

A lot of work has gone into this release. We have quite a few security
related fixes. Then there are updates to Dutch, Norwegian, Slovenian
and Vietnamese. Attila, who never seems to get tired, updated the
Hungarian tables and did some general cleanups in the tables.

Also due to some mishap our domain expired and we could not re-acquire
it. So we had to change our domain to ~liblouis.io~.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/35?closed=1][the list of closed
issues]].

** New features
** Bug fixes
- Fixed several buffer overflow errors in ~lou_setDataPath~,
  ~lou_logFile~ and ~resolveSubtable~ thanks to Marsman1996.
** Braille table improvements
- Fix a deprecation warning in Bulgarian 6 dots thanks to Attila
  Hammer.
- Fix two broken space replacement rules for ZERO WIDTH SPACE and WORD
  JOINER thanks to Attila Hammer and Norbert Markus.
- Fixes to Hungarian Braille exceptions and hyphenation thanks to
  Attila Hammer. This results in a much improved back-translation of
  capitalized words.
- Support for both 8 and 6 dot math symbols in Hungarian thanks to
  Norbert Markus.
- Update Dutch 8-dot computer braille table to the 2022 standard
  thanks to Leonard de Ruijter and the Dutch Braille Authority.
- There are updates to the Norwegian braille standard. Most notably
  URLs and email addresses are no longer surrounded by braille
  patterns unless present in the original document. Thanks to Lars
  Bjørndal.
- Add some missing character definitions to Slovenian computer
  braille, thanks to Jožef Gregorc.
- Corrections and additions to Vietnamese thanks to Dang Hoai
  Phúc. Includes a new computer braille table.
** Other changes
- Change the domain name from liblouis.org to liblouis.io thanks to
  Christian Egli.
- Simplify the Danish test to contain fewer files thanks to Bue
  Vester-Andersen and Bert Frees.
- Add the tests and the examples of the Python bindings to the
  distribution tarball. Thanks to Rob Beezer for spotting this
  oversight.
** Deprecation notice
- The ~lou_setDataPath~ and ~lou_getDataPath~ functions have been
  deprecated. Please migrate to one of the other ways to set the table
  search path:
  - The recommended and most straightforward way to set the search
    path is to set the ~LOUIS_TABLEPATH~ environment variable.
  - You can also set a custom table resolver function through
    ~lou_registerTableResolver~.
  - If you use the metadata based query API and haven't set the
    ~LOUIS_TABLEPATH~ environment variable, you can use the
    ~lou_indexTables~ function to tell Liblouis which files (not
    directories) to search.
  - Finally, there is the fallback solution of using absolute file
    paths.
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- vi-cb8.utb (replaces vi.ctb)

*** Renamed
None

*** Removed
- vi.ctb (replaced by vi-cb8.utb)

* Noteworthy changes in release 3.24.0 (2022-12-05)
This release contains major updates to Hungarian, UEB, and Chinese
bopomofo braille. Danish has been completely reworked and there is now
support for the Danish braille standard 2022. There are also some new
tables so that liblouis can now generate Georgian computer braille,
Swahili (Kenya) and Chichewa (Malawi). Aside from that there is the
usual assortment of code cleanups and bug fixes.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/34?closed=1][the list of closed
issues]].

** Braille table improvements
- New grade 1, 1.2, 1.3, 1.4, 1.5 and 2 tables for Swahili (Kenya) and
  grade 1 table for Chichewa (Malawi) thanks to Jake Kyle, Dipendra
  Manocha and Martin Kieti.
- Improvements to Hungarian thanks to Attila Hammer.
- Update braille patterns of some Chinese characters and phrases in
  the Chinese bopomofo braille table thanks to Bo-Cheng Jhan.
- Add experimental Georgian computer braille table thanks to Harris
  Mowbray and Mariam Mikiashvili.
- Updated the Danish tables to the new 2022 Danish braille standard
  thanks to Bue Vester-Andersen.
  - Limited contraction level (grade 2l or 1.5) is no longer part of
    the Danish braille standard 2022.
  - There is no longer any need for "literary" tables. In Danish
    braille, capital letters are now always indicated, and steps have
    been taken in the standard to ensure better back-translation.
  - As requested by The Danish Braille Committee, the tables for the
    1993 standard will be kept as an option for at least a year. All
    the 1993 tables have been renamed to include "_1993" in the
    filename, so the new tables will be used as default.
- Improvements to UEB thanks to James Bowden.
  - Add new sign for German sharp S (ICEB July 2022)
  - Fix a couple of acronyms which require grade 1 indicator (LLB, LLP)
  - Fix placement of numeral sign in letters comma digits
  - Review rules for "under" and "there" contractions
** Deprecation notice
- None
** Backwards incompatible changes
- None
** New, renamed or removed tables
*** New
- sw-ke-g1-2.ctb
- sw-ke-g1-3.ctb
- sw-ke-g1-4.ctb
- sw-ke-g1-5.ctb
- sw-ke-g1.utb
- sw-ke-g2.ctb
- ka.utb
- ny-mw.utb
- The following files now all refer to the corresponding tables for
  Danish braille 2022:
  - da-dk-g08.ctb
  - da-dk-g16.ctb
  - da-dk-g18.ctb
  - da-dk-g26.ctb
  - da-dk-g28.ctb
  - da-dk-octobraille.dis
*** Renamed
- The old Danish tables for the now deprecated 1993 standard have been
  renamed to include "1993" in the filename:
  - da-dk-g08.ctb -> da-dk-g08_1993.ctb
  - da-dk-g16.ctb -> da-dk-g16_1993.ctb
  - da-dk-g16-lit.ctb -> da-dk-g16-lit_1993.ctb
  - da-dk-g18.ctb -> da-dk-g18_1993.ctb
  - da-dk-g26.ctb -> da-dk-g26_1993.ctb
  - da-dk-g26-lit.ctb -> da-dk-g26-lit_1993.ctb
  - da-dk-g26l.ctb -> da-dk-g26l_1993.ctb
  - da-dk-g26l-lit.ctb -> da-dk-g26l-lit_1993.ctb
  - da-dk-g28.ctb -> da-dk-g28_1993.ctb
  - da-dk-g28l.ctb -> da-dk-g28l_1993.ctb
  - da-dk-octobraille.dis -> da-dk-octobraille_1993.dis
*** Removed
None

* Noteworthy changes in release 3.23.0 (2022-09-05)
This release contains significant updates to many existing braille
tables (Chinese bopomofo, Hungarian, Japanese, Russian, Swedish, UEB
grade 2 Ukrainian). On top of that it also contains new tables for
/Chinese Common Braille Scheme/, Kinyarwanda and Luganda thanks to
Cary-Rowen and Jake Kyle. Behind the scenes Samuel Thibault has been
working tirelessly to fix memory related bugs.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/33?closed=1][the list of closed
issues]].

** New features
- None
** Bug fixes
- Fix a problem in the parsing of faulty unbalanced context
  expressions. Thanks to Samuel Thibault.
- Fix a buffer overflow problem when ~output.length~ is larger than
  ~input.length~. Thanks to Samuel Thibault.
- Fix an endless loop in the handling of computer braille. Thanks to
  Bert Frees.
** Braille table improvements
- Remove computer braille from Japanese Kantenji as it is not part of
  the standard. Thanks to Kensaku Yoza.
- Bring Swedish tables up to date with the latest standard published
  by Punktskriftsnämnden (the Swedish Braille Authority) in 2009. The
  table for uncontracted braille was replaced and new tables for
  (partially and fully) contracted braille have been added. Thanks to
  David Renström from Insyn Scandinavia AB.
- Improvements to Hungarian (added more exceptions) and migration to
  the ~nonumsign~ opcode thanks to Attila Hammer.
- Fixed a bug in the Ukrainian table that led to wrong translation of
  some uppercase letters. Thanks to Andrey Yakuboy and Bert Frees.
- Augment the UEB grade 2 tables to resolve an ambiguity between lower
  groupsigns and punctuation at the beginning of words by placing a letter
  sign at the front of punctuation. This resolves an ambiguity between, for
  example, "discount" and ".count". Thanks to Krzysztof Drewniak.
- Add a new table for /Chinese Common Braille Scheme/ which is a type
  of braille used for spelling Mandarin Chinese. It is a variant of
  the /Chinese Current Braille System/ but has more perfect marking
  rules and produces less ambiguity than the latter. For more
  information see the comments in ~zhcn-cbs.ctb~. Thanks to Cary-Rowen
  and Frank.
- Updates to the Chinese bopomofo braille table thanks to Bo-Cheng
  Jhan:
  - Update braille patterns of some Chinese characters and phrases
  - Add braille patterns for various Greek symbols
  - Add "Math rules" section and the mixed number rule
  - Add braille patterns for ☐ (⣏⣀⣹), ☑ (⣏⣿⣹), and ☒ (⣏⣭⣹)
- New table for Kinyarwanda braille thanks to Jake Kyle from Compass
  Braille.
- New table for Luganda braille thanks to Jake Kyle from Compass
  Braille.
- Improvements to the Russian contracted braille table
  thanks to Andrey Yakuboy:
  - Now prefixes "из" and "без" are correctly contracted
    before hard sign (ъ).
  - Fixed a contraction for word "кое-где", now it is contracted
    according to rules.
  - Other minor fixes and improvements.
** Other changes
- None
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- None
** New, renamed or removed tables
*** New
- zhcn-cbs.ctb
- lg-ug-g1.utb
- rw-rw-g1.utb
- sv-g0.utb
- sv-g1.ctb
- sv-g2.ctb
*** Renamed
None
*** Removed
- Se-Se-g1.utb

* Noteworthy changes in release 3.22.0 (2022-06-06)
This is a major release. On the Braille tables side there is a new
table for German grade 2 with capitalization and there are updates to
the Dutch, German Hungarian, Punjabi, Russian, UK Braille Computer
Notation and Slovak tables. Christian added a new opcode to indicate
the end of a number where the number doesn't end at a space character.
Last but not least Samuel, Martin and Han have put a lot of work into
checking for and fixing memory problems.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/32?closed=1][the list of closed
issues]].

** New features
- Add a new opcode ~nonumsign~ that helps with indicating the end of a
  number when it doesn't occur at the end at the end of a word such as
  '123abc' for example. For more details see the documentation. Thanks
  to Christian Egli.
** Bug fixes
- Prevent a memory overflow in ~compilePassOpcode~ thanks to Martin
  Gieseking. This was reported in [[https://github.com/advisories/GHSA-xrp8-mw8v-p6mq][CVE-2022-26981]] and should now be
  fixed.
- Prevent processing of characters beyond the string end in
  ~parseChars~ thanks to Martin Gieseking.
- Prevent an invalid memory writes in ~compileRule~. Thanks to Han
  Zheng for reporting it and to Christian Egli for fixing it.
** Braille table improvements
- Improvements to German braille:
  - Improve handling of single letters in grade 2 thanks to Mischa
    Künzle.
  - Improve handling of emphasis thanks to Bert Frees.
  - Add a table for grade 2 /with capitalization/ thanks to Christian
    Egli.
- Fix a problem with Ñ in Dutch braille thanks to Paul Rambags
- Updated Slovak Braille table to be inline with the 2021 Slovak
  braille usage guidelines.
- Fixed a problem with the '+' symbol in UK Braille Computer Notation
  thanks to Mario Arias.
- Major improvements to the Hungarian braille tables thanks to Attila
  Hammer.
- Make Punjabi table to behave the same as Duxbury in forward
  translation and more reliably than Duxbury in back
  translation. Thanks to Jake Kyle.
- Improvements to the Russian and other Cyrillic tables thanks to
  Andrey Yakuboy:
  - Now all Russian based tables return braille Unicode braille by
    default when forward translating, no need to include
    ~ru-unicode.dis~ manually.
  - French letters (æ, ë and ï) have been added to the Russian
    literary braille table.
** Other changes
- Integrate sanitizer tests in the CI pipeline and fix a large number
  of memory problems (leaks, overflow and undefined behavior) thanks
  to Samuel Thibault.
- Removed the "experimental" label from the functions ~lou_indexTables~,
  ~lou_findTable~, ~lou_findTables~, ~lou_getTableInfo~ and
  ~lou_listTables~ (the meta data query API).
- Fix a build problem when using Clang 11 on macOS thanks to Robert
  Scott.
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
** New, renamed or removed tables
*** New
- de-g2-detailed.ctb
*** Renamed
- None
*** Removed
- None

* Noteworthy changes in release 3.21.0 (2022-03-07)
This release sees major updates for Hungarian and German. The Swiss
Library for the Blind, Visually Impaired and Print Disabled has agreed
to upstream their tables and Attila Hammer has adapted Hungarian to
the latest standard. A bug in numeric mode was fixed which should it
make more useful for languages other than UEB. Finally there are
fixes for Norwegian and Danish.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/31?closed=1][the list of closed
issues]].

** New features
- New table for German 6-dot computer braille thanks to the Swiss
  Library for the Blind, Visually Impaired and Print Disabled
** Bug fixes
- When numeric mode was enabled, i.e. when a table contains any of the
  ~numericmodechars~, ~midnumericmodechars~ or ~numericnocontchars~
  opcodes, contraction was automatically disabled. This is required
  for UEB but not necessarily so for other braille systems (as
  mentioned in [[https://github.com/liblouis/liblouis/issues/615][issue 615]]). This has now been changed so that
  contraction is only disabled if the ~nocontractsign~ has been
  defined. Thanks to Christian Egli.
** Braille table improvements
- Fixed emphasis, section sign and dash between numbers in Danish
  tables thanks to Bue Vester-Andersen.
- Correct latin small letter sharp s in Norwegian thanks to Lars
  Bjørndal and Dawn Renouf Bjørneby.
- Major improvements to German Braille thanks to the Swiss Library for
  the Blind, Visually Impaired and Print Disabled
  - Improvements to emphasis handling in German tables and greatly
    extended test coverage.
  - All the improvements from the tables formerly known as bidi tables
    were merged in the main tables and are now used by both tables.
    The bidi tables have been renamed to "detailed". Essentially the
    detailed tables provide capitalized Braille which helps with the
    back-translation.
  - Upstream all improvements from the ~sbs-braille-tables~.
- Improvements to the Hungarian tables thanks to Attila Hammer.
  - Improved back-translation, notably of words containing special
    consonants like "szsz" or "ssz".
  - Extended the Hungarian grade 1 "braille input" (back-translation
    aided by special extra dot patterns).
  - Implemented latest update to the Hungarian braille standard (for
    example the characters "\" and "|" were changed).
** Other changes
- Make ~autogen.sh~ work on MacOS, thanks to Ken Perry
** Deprecation notice
- None
** Backwards incompatible changes
** Invisible changes
** New, renamed or removed tables
*** New
- de-comp6.utb

*** Renamed
- de-g0-bidi.utb -> de-g0-detailed.utb
- de-g1-bidi.ctb -> de-g1-detailed.ctb

*** Removed
None

* Noteworthy changes in release 3.20.0 (2021-12-06)
This is a major release. Not only in terms of table additions and
updates but also in the way the tables are written. Bert has replaced
the ~uplow~ opcode with a more generalized ~base~ opcode. This clears
up the path for a more generalized handling of emphasis and uppercase
characters. In the course of this simplification some bugs with
computer braille were discovered and fixed.

On the Braille tables side there is a brand new table for braille
kanji and there are major updates to the Polish, Chinese, Russian
literary and the UEB tables.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/30?closed=1][the list of closed
issues]].

** New features
- There is an experimental new feature that allows a table writer to
  write table macros. This feature is disabled by default. Macros are
  a helpful tool for refactoring, however as it stands the feature is
  not mature and might disappear in future releases.
- Add a new opcode ~base~ that associates a character with another
  already defined character. Think of it as a generalized form of
  ~uplow~. A typical use of this opcode is for defining a pair of
  letters, a lowercase and the corresponding uppercase.
** Bug fixes
- Fix a problem with the dot 7 capitalization indicator in computer
  braille thanks to Bert Frees.
** Braille table improvements
- New table for Kantenji (or "braille kanji", a Japanese braille
  system) thanks to Kensaku Y.
- Improvements to Polish literary braille table thanks to Łukasz
  Golonka.
  - use correct representation of indexes for squared, cubed etc.
  - use correct representation for fractions
  - change symbol used for underscore from dots 46 to 6
  - add U+2212 minus symbol (also to computer braille table)
- Updates to the Chinese bopomofo braille table thanks to Bo-Cheng
  Jhan.
  - Complete translation of CJK Radicals Supplement
  - Change the default braille pattern of '蛤' to ⠗⠜⠂
  - Correct the default braille pattern of many Chinese characters
  - Add various Chinese phrases involving exceptions of braille
    patterns
  - Add a math symbol '◊' (⠫⠓)
- Improvements to the Russian literary (uncontracted and contracted)
  braille thanks to Andrey Yakuboy.
  - If the dot sign ('.') is after digits at the beginning of a string,
    the braille dot 6 isn't inserted between the last digit and the
    dot. This is necessary for items' numbers of numbered lists.
  - Back translation for French letters has been disabled because of
    conflicts with punctuations.
  - Back translation for Latin (mostly English and German) letters has
    been improved.
  - The definition of the 7/8 fraction (U+215E) has been fixed.
  - Placement of spaces around math symbols has been improved
    according to the Russian braille rules.
  - The apostrophe sign ("'") and the right tick sign (u+2019) are
    displayed correctly if they're in the end of a word (English, for
    example).
  - New contractions have been added and minor bugs have been fixed in
    the Russian contracted braille table.
- New display table (~ru-brf.dis~) has been added. It adds support of
  Braille ASCII for Russian and other Cyrillic tables. Thanks to
  Andrey Yakuboy.
- Improvements to UEB thanks to James Bowden.
  - Fixed placement of numeric indicator in letters dot numbers.
  - Added more mathematical symbols.
  - Added the four new allowed shortform extension words.
  - Improvements to words starting with "dis(h)" and "cross(h)".
- Implement alphabet change indicator in Dutch braille thanks to Bert
  Frees.
** Other changes
** Deprecation notice
- None
** Backwards incompatible changes
- The ~uplow~ opcode has been removed and replaced with the more
  general ~base~ opcode.
** Invisible changes
** New, renamed or removed tables
*** New
- ru-brf.dis
- ja-kantenji.utb
- latinUppercaseComp6.uti

*** Renamed
None

*** Removed
- ru-ru.dis
- cs-letterDef8Dots.uti
- ru-chardefs.cti
- nl-g0.uti
- nl-BE-g0.utb

* Noteworthy changes in release 3.19.0 (2021-09-06)
For this release Bert Frees has been hard at work to clean up the code
base. He fixed a few bugs one of which was causing memory corruption.
Others have contributed corrections to braille tables or even provided
new tables. For example there are now tables for Tshivenda and for
Russian contracted braille.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/29?closed=1][the list of closed
issues]].

** Bug fixes
- Fix a bug in the ~uplow~ opcode thanks to Bert Frees.
- Fix a possible crash due to memory corruption thanks to Bert Frees.
** Braille table improvements
- The Norwegian 6 dots braille tables now correctly handles signs like
  section sign ('§' and '§§'), as well as numbersign ('#') before
  numbers. In addition the letters a with acute, o with tilde, n with
  long right leg and thorn are redefined. Phrases with capitals only
  are know handled correctly. All thanks to Lars Bjørndal.
- Fix a problem with 'ç' in Northern Kurdish thank to Imam Kahraman
  and Christian Egli.
- Add support for back translation in Russian literary braille thanks
  to Andrey Yakuboy.
- In Russian literary braille, if the letters 'Ё' and 'Й' consist of two code
  points, they are displayed correctly.
- Add new Russian contracted (grade 1) table thanks to Andrey Yakuboy and
  Ekaterina Anisimova.
- Update to Urdu, mostly to cater for spelling variations found in
  source text. Thanks to Jake Kyle.
- New contracted braille table for Tshivenda created by Christo de
  Klerk at the request and under the auspices of the South African
  Braille Authority.
- Fix in Arabic computer braille table thanks to Ikrami Ahmad:
  - back-translate 256 to Latin full stop
- Fix translation of URLs and file paths in Polish grade 1 table,
  thanks to Łukasz Golonka.
** Other changes
- Fix the build script for Microsoft ~nmake~ thanks to Leonard de
  Ruijter.
** Deprecation notice
- None
** Backwards incompatible changes
- None
** Invisible changes
- Major refactoring of ~compileTranslationTable.c~ thanks to Bert
  Frees. Thanks to these changes a few bugs were found and fixed in
  the code and a few tables.
** New, renamed or removed tables
*** New
- ru-ru-g1.ctb
- ve-za-g1.utb
- ve-za-g2.ctb

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.18.0 (2021-06-07)
This release brings support for many new languages: There is support
for six new languages from South Africa, Northern Kurdish, Kazakh,
Tatar, Yakut, Bulgarian literary braille and finally Khmer, Burmese
and Vietnamese. Aside from that there are also major improvements to
Afrikaans, Russian literary braille, Uzbek and Hebrew Computer
Braille.

I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/28?closed=1][the list of closed
issues]].

** Bug fixes
- Don't silently ignore the last line of a table when it doesn't end
  with a new line character. Thanks to Bert Frees.

** Braille table improvements
- New contracted braille table for the isiXhosa and
  isiZulu languages created by Christo de Klerk and Laurent Cadet de
  Fontenay at the request and under the auspices of the South African
  Braille Authority.
- New contracted braille table for the Sesotho, Setswana and Sepedi
  languages created by Christo de Klerk at the request and under the
  auspices of the South African Braille Authority.
- New braille table for Northern Kurdish thanks to Imam Kahraman.
- Fix a problem with ']' in Finnish 8 dot braille thanks to Christian
  Egli. The real problem was an unintended continuation line.
- Major update to the grade 2 Afrikaans table. It now implements the
  new Afrikaans rules adopted and implemented recently by the South
  African Braille Authority. The rule changes simplify and rationalize
  the rules, especially those based on pronunciation. 571 of the list
  of 25912 test words were impacted by the changes and all have been
  corrected.
- Improvements to the Russian literary braille tables thanks to Andrey
  Yakuboy and Bert Frees:
  - Fixed a bug in ru-litbrl-detailed.utb that was causing a capital
    sign to be missing for Cyrillic uppercase letters after Latin
    letters.
  - Fixed a bug in ru-litbrl-detailed.utb that was causing a number
    sign to be missing in some cases.
  - Added more accented letters
- New tables for Kazakh uncontracted, Tatar uncontracted and Yakut
  uncontracted braille thanks to Andrey Yakuboy.
- Added more apostrophe symbols to English Computer Braille Code table
  thanks to BAUM Engineering.
- Small fix to Italian computer braille thanks to Simone Dal Maso
- New table for Bulgarian literary braille thanks to Румяна Каменска.
- Fixes to Uzbek grade 1 thanks to BAUM Engineering.
  - capital sign for Roman numbers
  - signs (math, parentheses and other)
  - sh and ch inside a word
  - g and o with different accent marks
- Major overhaul of the 8 dot Hebrew Computer Braille table thanks to
  Adi Kushnir
  - Fixed Hebrew input to properly work. It did not work at all before.
  - Added Russian support
  - Added special European characters
  - Fixed Arabic support.
  - Fixed some symbols to comply with the Israeli standard for
    computer Braille.
  - Changed display name from Israeli Multilingual to just indicate
    Hebrew.
- New tables for Khmer, Burmese (contracted and uncontracted) and
  Vietnamese (uncontracted, partially and fully contracted, as well as
  a variant for Southern Vietnam) thanks to Dang Hoai Phúc.
** Other changes
- Brilliant simplification of the table parser internals thanks to
  Bert Frees
** New, renamed or removed tables
*** New
- kk.utb
- sah.utb
- tt.utb
- xh-za-g1.utb
- xh-za-g2.ctb
- zu-za-g1.utb
- zu-za-g2.ctb
- nso-za-g1.utb
- nso-za-g2.ctb
- sot-za-g2.ctb
- tsn-za-g2.ctb
- bg.utb
- kmr.tbl
- vi-vn-g0.utb
- vi-vn-g1.ctb
- vi-vn-g2.ctb
- vi-saigon-g1.ctb
- my-g1.utb
- my-g2.ctb
- km-g1.utb

*** Renamed
None

*** Removed
- he.ctb -> superseded by he-IL-comp8.utb
- vi-g1.ctb -> superceded by vi-vn-g1.ctb

* Noteworthy changes in release 3.17.0 (2021-03-08)
This release stands in the tradition of small incremental improvements
that make it another fine and solid release. Andrey Yakuboy put in a
lot of work to improve Russian literary and computer braille. He also
provided a new table for Belarusian uncontracted and computer braille.
Aside from that there are numerous improvements in Braille tables such
as French, Polish and Urdu. The documentation has been improved as has
the table meta marking the tables whether they are geared towards
forward or backwards translation. I'd like to thank everybody for
helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/27?closed=1][the list of closed
issues]].

** Braille table improvements
- The backtranslation of æ in French 6 dot braille has been fixed
  thanks to André-Abush Clause.
- The definition of the vertical line symbol (|) in the Russian
  computer braille table was corrected thanks to Andrey Yakuboy.
- Improvements to the Russian literary braille thanks to
  Andrey Yakuboy:
  - Letters which are used in Old-Russian texts were added.
  - Arrows, integrals and other symbols were added.
  - the horizontal bar symbol (u+2015) was added and marked as a
    dash-symbol.
  - Now accent marks are put before a letter according to the Russian
    braille rules.
  - Many bugs with processing space-symbols were fixed.
  - Improvements to processing dialogs and direct speech.
  - Improvements to processing letters of different alphabets.
- New tables for Belarusian uncontracted and computer braille thanks
  to Andrey Yakuboy.
- Various fixes to Polish tables thanks to Łukasz Golonka:
  - Add em dash to both computer and literary Polish tables
  - Remove some definitions which made it impossible to back translate
    quoted strings from the Grade 1 table
  - Fix back translation of capital M and add tests for back
    translation of all Latin capital letters for Grade 1 table
- Update to Urdu thanks to Jake Kyle:
  - Revised definitions of SUPERSCRIPT ALEF and ARABIC LIGATURE ALLAH
    ISOLATED FORM.
  - Changed contractions of ٹھ, ان, اِن, بے, بی, اَور and اور.
  - Dots 3-3 used for repeated words instead of 6-6.
** Other changes
- Fixed some valgrind issues thanks to André-Abush Clause.
- Improve the documentation of /caps/ opcodes thanks to Bue
  Vester-Andersen.
- Add meta data to all tables indicating whether a table is geared
  towards forward or backwards translation or both. Again thanks to
  Bue Vester-Andersen.
** New, renamed or removed tables
*** New
- bel.utb
- bel-comp.utb
*** Renamed
None
*** Removed
None
* Noteworthy changes in release 3.16.1 (2020-12-01)
In the frenzy to ship the 3.16.0 release a little mishap slipped in.
The test suite contains an error and consequently doesn't pass. It was
promptly discovered and fixed by Samuel Thibault. So we present to you
the real, hopefully fixed 3.16 release. Let's name it 3.16.1.

* Noteworthy changes in release 3.16.0 (2020-11-30)
This release is mostly the work of Bert Frees. He has put in a lot of
work and pushed some major improvements with regards to how emphasis
is handled (and how this is documented). He fixed a crash when reading
URLs using computer braille. He also worked with many contributors to
get their improvements in. So we have better support for UEB, Dutch,
Urdu, Malayalam, Arabic, Bashkir, Uzbek, Russian computer braille and
for EBAE. I'd like to thank everybody for helping to bring liblouis
forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/26?closed=1][the list of closed
issues]].

** New features
- A new opcode ~noemphchars~ was added. This gives you more control
  over the placement and scope of various emphasis indicators. Thanks
  to Bert Frees.
** Bug fixes
- Fix an endless loop when using =compbrlAtCursor= thanks to Bert
  Frees
** Braille table improvements
- Improvements to US EBAE conformance with BANA emphasis guidelines
  thanks to Benetech.org
- Fixed a problem with apostrophe in Malayalam thanks to Jake Kyle
- Improvements to contraction use in UEB thanks to James Bowden. In
  particular the checkmark (U+2713) is added, the emdash (U+2014) is
  fixed, the right single quote used as apostrophe between letters is
  fixed and finally some more accented letters have been added.
- Improvements to Urdu Braille and Malayalam thanks to Jake Kyle
- Add characters for Bashkir and Uzbek languages to the Russian
  computer braille table. Thanks to Andrey Yakuboy.
- New table for Bashkir uncontracted braille thanks to Rustam
  Churagulov and Gabidullin Yunir.
- Updated =<= and =>= symbols in the Arabic tables thanks to Ikrami
  Ahmad.
- Improvements to Dutch thanks to Bert Frees.
  - Every word part in a capitalized compound word counts in the
    length of a passage.
  - ~begcapsphrase~ is allowed to start in a word preceded by
    punctuation.
- Improved translation of ligatures in UEB thanks to Bert Frees.
- Multiple improvements to the Russian literary braille thanks to
  Andrey Yakuboy and Bert Frees:
  - Many new symbols (punctuation, bullets, math symbols, etc) have
    been added.
  - The table now includes the international phonetic alphabet table.
  - Punctuation after digits and fractions is now marked with dot 6 to
    avoid ambiguities.
  - Other changes to conform better with Russian braille rules.
  - A new table that indicates capital letters was added. This is the
    new recommended Russian table for braille display users.
  - Removed the old ~ru-ru-g1.utb~ in favor of ~ru-litbrl.ctb~ and
    ~ru-litbrl-detailed.utb~.

** Other changes
- Support for Python 2 has been removed. The python bindings now only
  support Python 3. The deprecation notice was announced in Release
  3.13 and the removal is finally done now.
- Improvements to the placement of emphasis and capital indicators.
- The documentation for the emphasis opcodes has been further improved
  thanks to Bert Frees.
** Deprecation notice
- None
** Backwards incompatible changes
- ~emphmodechars~ can and must now be set per emphasis class.
** Invisible changes
- The emphasis and capitalization handling code has seen major 
  streamlining, simplification and tidying thanks to Bert Frees.
** New, renamed or removed tables
*** New
- ba.utb
- ru-litbrl-detailed.utb
- en-us-emphasis.uti

*** Renamed
None

*** Removed
- ru-ru-g1.utb

* Noteworthy changes in release 3.15.0 (2020-08-31)
This release contains updates to the Afrikaans, Malayalam, Malay,
Israeli, classical English and Portuguese tables. It also contains a
new table for Coptic thanks to first-time contributor Ibraam Nasif.
Behind the scenes there have been major changes to the
cross-compilation tool-chain that will finally allow us to ship
pre-built windows binaries that contain ~lou_checkyaml.exe~.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/25?closed=1][the list of closed
issues]].

** New features
None

** Bug fixes
None

** Braille table improvements
- New computer braille table for the Coptic language thanks to Ibraam
  Nasif from Coptic Bishopric of Youth
- Improvements to Afrikaans thanks to Christo de Klerk
  - Fixed correct handling of the ŉ character (0x149)
  - Prevent contraction of
    - "self" in "selfoon", "selfone",
    - "ui" in words and names like "quisling", "quidproquo",
      "quiëtis", "Quinten", "Quintus",
    - "er" in words like "konstituering".
- Improved table for Malayalam grade 1 thanks to Jake Kyle.
  - Fixed rules for Candrakkala character at the end of a word.
  - Fixed rules for letters ര മ ങ in certain contexts.
  - Improved back-translation.
- Improvements to grade 2 Malay braille thanks to Herbert Koh.
- Improvements to Israeli 6-dot thanks to BAUM Engineering.
  - Fixed number sign for Arabic digits.
  - Fixed Hebrew letters with dagesh.
- Added bullets to the classical English tables, thanks to Bue
  Vester-Andersen
- Improved Portuguese grade 1 thanks to Bue Vester-Andersen.
  - Fixed forward translation of &, <, >, `, ¶ and '.
  - Improved back-translation. The table is now tagged as going both
    forward and backward.
  - Added missing square root sign.

** Other changes
None

** Deprecation notice
None

** Backwards incompatible changes
None

** Invisible changes
- Major rework of the cross-compilation tool-chain. There are now
  Docker images that should allow for local builds of binaries for 32
  and 64 bit. These include the libyaml library so the binaries contain
  ~lou_checkyaml.exe~. This will allow table creators to test their
  changes locally under windows.

** New, renamed or removed tables
*** New
- cop-eg-comp8.utb

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.14.0 (2020-06-02)
This release contains major updates to Arabic, Dutch 8-dot computer
braille, German, Russian computer braille, Ukrainian computer braille
and Uzbek. Also there are new tables for Israeli multi-language
Hebrew/Arabic/English braille and Malay. Aside from that there have
been many code cleanups and bug fixes.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/24?closed=1][the list of closed
issues]].

** New features
- Add new test mode in ~lou_checkyaml~ for testing display
  tables. Thanks to Bert Frees.

** Bug fixes
- Work around a bug that causes an endless loop in French uncontracted
  braille thanks to André-Abush Clause.

** Braille table improvements
- Updates to the Russian computer braille table thanks to Andrey
  Yakuboy:
  - Fixed diacritics, Greek letters and Hebrew.
  - Added new Cyrillic letters.
  - Fixed several minor bugs.
- New table for Uzbek braille thanks to BAUM Engineering.
- New table for Ukrainian computer braille thanks to Andrey
  Yakuboy and Oleh Shpai.
- Improvements to Arabic thanks to Ikrami Ahmad and Mada, Qatar
  Assistive Technology Center.
  - Added a lot of new symbols (algebra, geometry, Greek, etc.) to the
    grade 1 table.
  - Changed some symbols for less conflicts with grade 2.
  - Implemented letter sign / grade 1 indicator to cancel numbers and
    inhibit contractions when in grade 2.
  - Updated 8-dot computer braille table for better (easier to
    memorize) presentation of basic math symbols and punctuation
    marks.
  - Improved back-translation.
- Improvement to German thanks to Bue Vester-Andersen.
  - Removed superfluous letter sign before certain lesser-used
    accented letters.
- Final version of Dutch 8-dot computer braille table thanks to
  Leonard de Ruijter.
- New Israeli multi-language Hebrew/Arabic/English tables for both
  uncontracted and computer braille. Thanks to BAUM Engineering and
  Erez Kugler from TSR Gaash.
- New table for grade 2 Malay braille (Malaysia) thanks to Herbert
  Koh.

** Other changes
- You can now use up to 256 ~noletsign~ characters in a table, thanks
  to Christian Egli.
- Major improvements to the documentation for the /Standing Alone
  Sequences/ and their related opcodes such as ~seqdelimiter~ and also
  clarifications regarding the ~begcaps~ and ~endcaps~ opcodes thanks
  to Bue Vester-Andersen.

** Deprecation notice
- The ~class~ opcode has been deprecated in favor of ~attribute~,
  which has been enhanced to do everything ~class~ can do.

** Backwards incompatible changes
None

** Invisible changes
** New, renamed or removed tables
*** New
- uz-g1.utb
- ar-ar-g1-core.uti
- ar-ar-math.uti
- he-IL.utb
- he-IL-comp8.utb

*** Renamed
None

*** Removed
- da-dk.dis :: This table has long been superseded by
  ~da-dk-octobraille.dis~.
- da-lt.ctb :: This table was a step on the way to defining a Danish 8
  dot standard. The table was referring to an old Danish Braille
  note-taker from the 80s and 90s, which is not used any more.
- fi1.ctb and fi2.ctb :: These tables are obsolete. Use
  ~fi-fi-8dot.ctb~ instead.

* Noteworthy changes in release 3.13.0 (2020-03-02)
A tremendous amount of work by lots of different people has gone into
this release. Bert Frees for example added new opcodes, fixed long
standing bugs (with emphasis and capitalization), made the
documentation more clear and helped table contributors bringing in
their improvements. Bue Vester-Andersen added major improvements to
Danish and German braille. This release also contains much improved
tables for Afrikaans, Russian computer braille, Urdu and Chinese.

On a personal note I'd like to say that this is the 20th release of
liblouis shipped by the current release team Bert Frees and Christian
Egli. I hope we can continue to do so.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/23?closed=1][the list of closed
issues]].

** New features
- The ~nocross~ opcode has been made into a prefix opcode, which means
  that it can now be used in combination not just with the ~always~
  opcode but also with other translation opcodes such as ~begword~,
  e.g. ~nocross begword sh 146~ for example. The old usage of the
  opcode no longer works, see [[Backwards incompatible changes]].
- Added a new opcode ~rependword~, needed to implement Malay
  braille. Thanks to Bert Frees.
- Emphasis and capitals can now be marked correctly in more
  cases. Thanks to Bert Frees.
  - When ~begemphword~ (~begcapsword~) is defined but not
    ~endemphword~ (~endcapsword~), use ~emphletter~ (~capsletter~) to
    mark every character in an emphasized (capitalized) part that ends
    in the middle of a word.
  - When ~begemphword~ (~begcapsword~) and ~begemph~ (~begcaps~) are
    both not defined, use ~emphletter~ (~capsletter~) to mark every
    emphasized (uppercase) letter.
  - ~capsnocont~ has no influence anymore on whether ~capsletter~ is
    used for every uppercase letter or not, see [[Backwards incompatible
    changes]].

** Bug fixes
- Fix a crash on sparc64 thanks to Samuel Thibault.
- Fixed a bug where the ~inputPos~ array was not monotonically
  increasing. This is a problem for language bindings that try to do
  hyphenation based on this information. Thanks to Bert Frees.
- A couple of small Coverity fixes thanks to David King.
- Fix an infinite loop involving multipass rules and backtranslation
  thanks to Bert Frees and Bue Vester-Andersen.
- Fix several problems in the Python bindings thanks to Leonard de
  Ruijter, Łukasz Golonka and André-Abush Clause:
  - Ensure that the mbcs encoding is always used to encode file path
    on Windows, especially when 'Unicode UTF-8' feature is enabled.
  - ~getTypeformForEmphClass~ was passed a decoded string on Python 3
    instead of an encoded one.
  - The same applies to ~compileString~. We encoded the input string,
    but never used that encoded one when passing it to liblouis.
- ~begemphword~ (~begcapsword~) and ~endemphword~ (~endcapsword~) are
  now used for single letters within a word when ~emphletter~
  (~capsletter~) is not defined.
- For backward translation the returned input length is now equal to
  the initial input length (as it is for forward translation) thanks
  to Bert Frees.

** Braille table improvements
- Improvements to Afrikaans thanks to Christo de Klerk
  - Fixed back translation of some lower words.
  - Fixed several contraction errors where contractions are based on
    pronunciation or occur where compound words join.
  - Eliminated grade 1 indicator where a single letter follows a
    single apostrophe to indicate an abbreviated word, e.g. 'k for ek.
  - Corrected the use of the grade 1 indicator in grade 2 with signs
    which would conflict with contractions, such as the trademark sign
    that would conflict with the contraction of tussen.
  - Fixed the back translation conflict between the UEB circle shape
    indicator and words containing $= being the contraction for
    "alge".
- Improvements to Russian computer braille table thanks to Andrey
  Yakuboy.
  - The table is now based on the Unicode character set. A lot of new
    characters were added that aren't in KOI8-R, including Greek,
    Hebrew, accented letters and so on.
  - For special characters we now follow the definitions from other
    software (JAWS, TSS, DBT) instead of following the American
    standard.
- Improvements to Urdu Braille thanks to Jake Kyle
  - Changed definition of \x0624 (Waw with hamza above) from dots 1256
    to dots 3-2456 following advice from proof reader.
  - Added 2 character versions of letter plus diactric (previously
    only the one character versions defined):
- Updates to the Danish Tables thanks to Bue Vester-Andersen:
  - Fixed back-translation for some JAWS Braille drivers, which
    deliver Unicode characters to Liblouis as input from a Braille
    keyboard.
  - Ensured proper use of letsign in connection with accented letters.
  - Re-arranged and strengthened tests to include all Unicode
    characters defined in the tables.
- Updates to the Chinese bopomofo braille table thanks to Bo-Cheng
  Jhan, Coscell Kao and Victor Cai.
- New experimental German tables for grade 0 (Basisschrift) and grade
  1 (Vollschrift) that are more suitable for back-translation, thanks
  to Bue Vester-Andersen.
  - All capital letters are marked.
  - Accented letters are translated using ~de-accents-detailed.cti~ to
    make the translation as detailed as possible.
  - Apostrophes and single quotation marks are translated the same.

** Other changes
- The documentation for the emphasis opcodes has been reworked and is
  now much more clear and accurate thanks to Bert Frees.

** Deprecation notice
- Python 2 is [[https://www.python.org/dev/peps/pep-0373/][no longer maintained]] since the beginning of this year.
  The current liblouis Python bindings work with both Python 2 and 3.
  However the support for Python 2 will be dropped in the next release
  (3.14) at the beginning of June 2020. If you have code that uses the
  liblouis Python bindings with Python 2 then please refer to the
  [[https://docs.python.org/3/howto/pyporting.html][official porting guide]] for help with migrating it.

** Backwards incompatible changes
- Since the ~nocross~ opcode has been made into a prefix opcode, it
  must now be used in combination with another opcode. For example
  ~nocross sh 146~ must now be written as ~nocross always sh 146~.
- The ~capsnocont~ opcode can not be used anymore to control whether
  ~capsletter~ is inserted for every uppercase letter. This now
  depends on whether ~begcaps~ and ~begcapsword~ are defined.

** Invisible changes
** New, renamed or removed tables
*** New
- de-g0-bidi-core.uti
- de-g0-bidi.utb
- de-g1-bidi-core.cti
- de-g1-bidi.ctb

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.12.0 (2019-12-02)
This release contains major updates to the UEB, Afrikaans, Chinese,
Danish and Polish tables. Aside from that there have been many code
cleanups, such as the elimination of many global vars and bug fixes
such as an endless loop or a crash in ~lou_translate~.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/22?closed=1][the list of closed
issues]].

** New features
None
** Bug fixes
- Fix a memory leak when several tables are specified and some of them
  that can't be resolved. Thanks to André-Abush Clause.
- Fix an endless loop with multipass rules where ~endReplace~ is
  smaller or equal to ~startMatch~. Thanks to Bert Frees and Bue
  Vester-Andersen.
** Braille table improvements
- Punctuation corrections in Ethiopic Braille thanks to Dr. Tamru E.
  Belay.
- Fixes to the Norwegian 8dot braille table in regards to 4 Sami
  characters, capital and small letters S and Z with caron. Thanks to
  Oddvar Øyan and Lars Bjørndal.
- Improvements to Afrikaans contracted braille thanks to Christo de Klerk
  - Over 50 cases have been corrected where braille rules were not
    correctly applied in words, mainly in those cases where
    contractions depend on pronunciation; for example, ui or ie must
    not be contracted in requiem.
  - Corrected contraction errors caused by start or end of input not
    properly taken into account.
  - Words are no longer contracted into lower word contractions when
    they are adjacent to lower punctuation, for example: "hier.
  - Words are now contracted into their lower contractions when they
    are adjacent to upper punctuation, for example: (hier.
- New draft table for Dutch 8-dot computer braille thanks to Leonard
  de Ruijter.
- Updates to the Chinese bopomofo braille table thanks to Bo-Cheng
  Jhan, Coscell Kao, 特種兵, 黃偉豪, and Victor Cai.
- Fixes to Polish grade 1, thanks to Łukasz Golonka
  - Removes some unneeded ~midnum~ symbols from the Polish Grade 1.
  - Fixes some symbols which weren't defined according to the
    specification.
  - Makes it possible to type dot from a braille keyboard.
  - Adds Greek letters and some commonly used math operators to both
    the Grade 1 and the computer braille table.
- Fix several conflicts in ~fr-bfu-comp68.cti~ with regards to the IPA
  Unicode range. These had been especially noticed when
  ~compbrlAtCursor~ mode flag was used. Thanks to André-Abush Clause.
- Major Improvements to contraction use in UEB thanks to James Bowden.
- Updates to the Danish Tables thanks to Bue Vester-Andersen:
  - Added miscelaneous Unicode characters to 8 dots grade 1 and 2
    (accented letters, punctuation, arrows and some math signs).
    Most of these characters have not been defined in the Danish
    Braille standard. This implementation is purely experimental,
    and the characters may be changed later.
  - Updated the 6 dots tables with more Unicode characters
    (no arrows or math signs).
  - Corrected a bug in 8 dots grade 2, which resulted in the
    "var" contraction not always being properly applied.
** Other changes
- Make sure the log callback uses the same calling convention as all
  the other exported functions. Thanks to Leonard de Ruijter.
- Fix a problem with Non-ASCII characters in file paths in the Python
  bindings, thanks to André-Abush Clause.
- Eliminate some of the globals variables thanks to Bert Frees.
- The display and the translation are now separated at least
  internally, thanks to Bert Frees. As a reminder, there are two
  phases to a braille conversion:
  - translation :: liblouis uses the rules in the translation table to
                   convert characters to dots
  - display :: display the dots as characters. Usually liblouis uses
               the characters defined in display rules (in display
               tables) but as a fallback it uses mappings defined in
               the translation table, e.g. letter rules.
- No longer install ~lou_compare~, a tool that is used to run
  regression tests for UEB. As it is only run during testing it will
  no longer be installed by default on a users machine.
- Remove a hidden feature of ~lou_translate~ that would cause it to
  crash if passed an invalid file name. Thanks to Christian Egli.
- Raise an error if a dot pattern can not be displayed instead of
  silently ignoring it thanks to Bert Frees.
** Deprecation notice
None

** Backwards incompatible changes
None

** Invisible changes

** New, renamed or removed tables
*** New
- nl-comp8.utb

*** Renamed
None

*** Removed
None

* Noteworthy changes in release 3.11.0 (2019-09-02)
A tremendous amount of work by Dave Mielke and Bert Frees has gone
into this release. They have improved liblouis for use on note taker
devices, for backwards translation and a number of languages. Many
other contributors (listed below) have also helped in fixing bugs and
improving braille tables, such as Dutch, Mongolian, Polish, Ancient
Greek, Danish, Irish, Chinese, and American Braille Computer Code.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/21?closed=1][the list of closed
issues]].

** New features
- Enable ~always~ rules with a single character and a single braille
  cell for back-translation. Thanks to Bue Vester-Andersen.
- Implement ~noUndefined~ mode for forward translation, thanks to Dave
  Mielke.
- Use fallback braille representations (NABCC) for rendering undefined
  characters in hexadecimal notation, thanks to Dave Mielke.
- Always render undefined characters, also ASCII characters, in
  hexadecimal notation.
- Add a new metadata field ~index-name~ for selecting a table from a
  list fast and efficiently. It has the most important information
  first and no redundant information. It should look nice when sorted.
  This in contrast to the existing ~display-name~ field which is for
  describing a table accurately and should sound good. Thanks to Dave
  Mielke and Bert Frees.

** Bug fixes
- Don't let a caps passage end on a word with no letters. Thanks to
  Bert Frees.
- Handle word resets in the last word of an caps or emphasis passage
  if the end indicator was placed before the word. Thanks to Bert
  Frees.
- Never convert to lowercase if ~capsletter~ is not defined. Thanks to
  Bert Frees.
- Fix position mapping for back-translation when ~noUndefined~ mode is
  active. Thanks to Dave Mielke.
- Fix bug where a translation would hang on words that match both a
  ~nocont~ and a ~repeated~ rule. Thanks to Dave Mielke.
- Fix bug where the effect of ~capsnocont~ would leak to the next word
  if that word starts with a capital. Thanks to Bue Vester-Andersen.

** Braille table improvements
- Fix an issue with ordinal numbers inside caps passages in Dutch
  braille. Thanks to Bert Frees.
- Improved back-translation for Mongolian thanks to Angaragerdene.
- Fixes to Polish grade 1 and Polish computer braille thanks to Łukasz
  Golonka.
- Improvements to Ancient Greek braille, which has been renamed "Greek
  international braille". A version with composed accents is made
  available as a .uti table. Thanks to Dave Mielke and Μαρια
  Γεωργακαράκου (Maria Georgakarakou).
- Various improvements to modern Greek thanks to Dave Mielke.
- Improvements and fixes to Spanish contracted braille. Details in
  #741. Thanks to Juan Pablo Bello.
- Improvements and fixes to the Danish tables. Thanks to Bue
  Vester-Andersen.
- Add a display table to match Word CX which is used in Norway and
  Sweden, and maybe also in other countries thanks to Lars Bjørndal.
- Fix handling of colon within number in Dutch braille, thanks to Jake
  Kyle.
- Fix translation of bullet and dot operators in Dutch braille, thanks
  to Paul Rambags
- Added North American Braille Computer Code table (~en-nabcc.utb~)
  which is the counterpart of the ~text_nabcc.dis~ display table.
  Thanks to Dave Mielke.
- Add support for the International Phonetic Alphabet (IPA) to the
  Chinese bopomofo braille table, thanks to Hurt Huang and Sponge
  Jhan. Various improvements, including dot patterns and test cases, to
  the Chinese bopomofo braille table, thanks to Sponge Jhan.
- Unified English Braille no longer displays a single underscore when
  multiple underscores are in the text, thanks to André-Abush Clause.
- Update to Afrikaans uncontracted braille and new table for contracted
  braille. Thanks to Christo de Klerk and Greg Kearney.
- Update Irish braille (contracted and uncontracted) to the May 2019
  version of the specification, thanks to Ronan McGuirk

** Other changes
- The python wrapper now encodes and decodes strings to/from UTF-16
  and UTF-32 using the surrogatepass error handler. This ensures that
  single UTF-16 surrogate characters are processed correctly by the
  wrapper and don't raise an encoding/decoding error. Thanks to
  Leonard de Ruijter.
- Metadata keys and values are now case insensitive, thanks to Dave
  Mielke.
- Remove ~unicodedefs.cti~. It was obsolete and never meant to be
  included by any tables. Instead use the online references as
  mentioned in the documentation now. See also #696.
- ~lou_checkyaml~ test reporting has been improved, thanks to Bert
  Frees. For example it now has a ~--verbose~ option so that printing
  of expected failures can be enabled.
- Hyphenation tables have been removed from tables except those needed
  for ~nocross~ rules, thanks to Bert Frees.

  The idea is that the caller (for example ~odt2braille~ or
  ~liblouisutdml~) should be able to decide for themselves which
  hyphenation table to use. The case in which a table contains nocross
  rules is an exception. In this case the hyphenation patterns are a
  real part of the table. Because it is not recommended to append an
  own hyphenation table in this case, a ~#-has-nocross~ metadata field
  was added to indicate that a table contains nocross rules.
- ~lou_hyphenate~ can now handle more than just words (sequences of
  letters), e.g compound words, thanks to Bert Frees.

** Deprecation notice
- The ~noUndefinedDots~ mode has been renamed to ~noUndefined~. For
  backwards compatibility ~noUndefinedDots~ is still available in the
  header file and in the Python bindings, as an alias for
  ~noUndefined~.

** Backwards incompatible changes
None

** Invisible changes
   - Internally separate more clearly the display and translation
     phases.

** New, renamed or removed tables
*** New
- grc-international-common.uti
- grc-international-composed.uti
- grc-international-decomposed.uti
- en-nabcc.utb

*** Renamed
- gr-bb.ctb -> grc-international-en.utb

*** Removed
- unicodedefs.cti
- fi-fi.ctb

* Noteworthy changes in release 3.10.0 (2019-06-03)
This release comes across as quiet, containing just the usual
assortment of braille table improvements, cleanups, bug fixes and the
classic buffer overflow patches. But beware, a lot has happened behind
the scenes. Bert and Davy have been adding a new opcode to handle
special emphasis situations. A number of annoying restrictions with
regards to names, such as class names have been removed thank to Bert.
And lastly also thanks to Bert it is now possible to define inline
display tables in your YAML tests.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/20?closed=1][the list of closed
issues]].

** New features
- Add a new opcode ~emphmodechars~. Thanks to Bert Frees and Davy
  Kager.

** Bug fixes
- Remove memoization in ~checkAttr~. It wasn't implemented correctly,
  caused some weird bugs and probably didn't do much for performance.
  Thanks to Bert Frees.
- Fix multiple buffer overflows in ~compilePassOpcode~. Thanks to
  Cheng Wen for the report and to Christian Egli for the fix.
- Fix a build problem when building without libyaml thanks to Bert
  Frees.

** Braille table improvements
- Added modified letters to UEB thanks to Mike Gray.
- Complete overhaul of the U.S. six-dot computer braille tables to
  align with the CBC standard thanks to Timothy Wynn. There is now a
  sub-table for EBAE (~en-us-compbrl.uti~) and a stand-alone table
  (~en-us-comp6.ctb~).
  - Conforms to the CBC standard from BANA for character definitions
    that differ from the 8-dot ASCII braille (11 punctuation marks).
  - Added rules for braille indicators, emphasis indicators, and
    isolated lower-cell signs to the stand-alone table.
  - Uncontracted and contracted EBAE tables no longer use dot 7 when
    in computer braille mode.
  - ~en-us-compbrl.ctb~ was deleted because it was identical to
    ~en-us-comp6.ctb~.
- Update Bopomofo-based Chinese Braille thanks to Sponge Jhan
  - Correct various dot patterns of Chinese characters.
  - Add more known pattern exceptions of Chinese characters.
  - Apply ~word~ opcode to 倔 and 据.
  - Change dot pattern of ＆ to 456-12346.
- ~de-de-comp8.ctb~ now has definitions for musical Unicode characters
  thanks to Daniel Mayr
- Emphasis improvements in Unified French 6 dots Braille thanks to
  Ludovic Oger.
- Improvements to Unified English braille, Grade 2 thanks to James
  Datray from Freedom Scientific.
- Numerous back-translation fixes to Grade 2 of UK English and Unified
  English Braille thanks to Anthony Tibbs.
- Updates to Dutch Braille thanks to Bert Frees
  - Hyphen cancels the effect of emphasis indicator
  - Left/right curly brackets
  - Write currency symbols in full if they come after the number

** Other changes
- Remove various restrictions on which characters and braille cells
  can be used in translation rules, thanks to Bert Frees.
- Remove some code duplication in ~pattern.c~ thanks to Bert Frees
- It is now also possible to define inline tables when a display table
  has been defined thanks to Bert Frees
- Nightly snapshots of liblouis are now also built for win64 thanks to
  Bert Frees

** Deprecation notice
None

** Backwards incompatible changes
None

** New, renamed or removed tables
*** New
- en-us-compbrl.uti

*** Renamed
- chardefs.cti -> en-chardefs.cti

*** Removed
- en-us-compbrl.ctb

* Noteworthy changes in release 3.9.0 (2019-03-04)
This release has seen a tremendous amount of work by Bert Frees. He
was instrumental in pushing the improvements for Latvian, Norwegian
and Slovenian. But most prominently he pushed the big change for space
and control character handling through the door. These characters are
now no longer hard coded in liblouis. This should solve a few long
standing issues. Other than that there is the usual assortment of code
improvements and cleanups.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/19?closed=1][the list of closed
issues]].

** New features
- None

** Bug fixes
- Fix a problem in the callback registration in the Python bindings
  thanks to Leonard de Ruijter.
- Fixed memory leaks created by block scope compound literals thanks
  to Martin Gieseking.
- The hard coded rules dealing with white space have been replaced
  with a normal table that is included in all tables. This fixes a
  number of bugs to do with space and control characters. This (big)
  change has been brewing for a couple of releases and has finally
  landed. Thanks to Christian Egli and Bert Frees.

** Braille table improvements
- Major extension of the German 8 dot computer braille table thanks to
  Ali-Riza Ciftcioglu. For example the Euro sign or quote characters
  are finally defined.
- Fix a few issues with Hungarian grade1 and grade2 Braille thanks to
  Attila Hammer.
- Various improvements to Norwegian thanks to Lars Bjørndal, Jostein
  Austvik Jacobsen, Ammar Usama and Bert Frees.
- Updates to Bopomofo-based Chinese Braille thanks to Sponge Jhan:
  Improved Braille representation of Chinese characters, and rewritten
  Kana rules using multipass statements.
- Implement the new Slovenian Braille standard thanks to Robert Merič
  and Bert Frees.
- Updates to Latvian Grade 1 Braille thanks to Artis Raugulis and Bert
  Frees.
- Fixes to English, U.S. Grade 2 (ABAE) thanks to jdatray.

** Other changes
- Don't search for tables in ~/usr/local/share/liblouis/tables~ (or
  the Windows equivalent) if ~LOUIS_TABLEPATH~ is set.
- The log levels in ~liblouis.h~ are no longer exposed as ~LOG_FOO~
  but instead are now prefixed. So ~LOG_WARN~ becomes ~LOU_LOG_WARN~
  for example to issue a warning from a C program using liblouis. The
  actual values remain the same, so the ABI remains stable.

** Deprecation notice
- The ~locale~ opcode was never implemented and was just silently
  ignored. It is now removed from the tables and a warning will be
  issued if it is found in a table.

** Backwards incompatible changes

** New, renamed or removed tables
*** New
- None

*** Renamed
- spaces.ctb -> spaces.uti

*** Removed
- None

* Noteworthy changes in release 3.8.0 (2018-12-03)
The major focus of this release is on braille table updates. There are
major updates to German, Arabic, Chinese, Turkish, Dutch, Czech,
Latvian, Spanish and Ethiopic. Some of these new tables have only been
possible because Bert Frees fixed some nasty long standing bugs behind
the scene. Also there is the usual assortment of code improvements and
cleanups.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/18?closed=1][the list of closed
issues]].

** New features
- None

** Bug fixes
- Fix support more than 4 classes thanks to Bert Frees.
- Fix capitalization of words that match ~nocont~ rules thanks to Bert
  Frees.

** Braille table improvements
- Defined the undefined character for the Czech tables thanks to Jan
  Hegr.
- Improvements to Unified English braille thanks to Mike Gray
- Updated the Dutch table to the new 2017.1 braille standard thanks to
  Davy Kager.
- Improvements to the Polish grade 1 table, to make back-translations
  of diacritics working
- Fixes to Latvian braille table thanks to Gatis Grintals and Artis
  Raugulis.
- Improvements to traditional Mainland Chinese braille and two-cell
  Chinese Braille thanks to Sunian Loomee.
- Update Bopomofo-based Chinese Braille to version 2018-11 thanks to
  Bo-Cheng Jhan
  - Correct the default braille pattern of many Chinese characters
  - Add various Chinese phrases involving exceptions of braille
    patterns
  - Modify dot patterns of dashes for readability reasons
- Added a table for Turkish grade 2 thanks to Uğur Gürbüz and Simon
  Aittamaa
- Major upgrade to the German tables. They have been upgraded to /Das
  System der deutschen Brailleschrift/ (2018). They are much smaller
  now as they are based on ~lou_maketable~. As they now work for any
  locale (be it Switzerland or Germany) they have been merged into one
  set of tables for the different grades. Thanks to Christian
  Waldvogel.
- New table for Arabic contracted braille thanks to Ikrami Ahmad.
- New table for Arabic computer braille thanks to Ikrami Ahmad.
- Improvements to Arabic uncontracted braille thanks to Ikrami Ahmad.
- Improvements to Ethiopic thanks to Tamru E. Belay.
- New table for Spanish contracted braille thanks to Juan Pablo Bello.

** Other changes
- Updated the ~lou_allround~ and ~lou_trace~ test tools to include all
  the mode flags described in the documentation of the
  ~lou_translateString()~ function, thanks to Bue Vester-Andersen

** Deprecation notice
- None

** Backwards incompatible changes
- The ~pass1Only~ flag has been deprecated for a while and is now
  removed from the code, thanks to Bue Vester-Andersen.

** New, renamed or removed tables
*** New
- tr-g2.ctb
- ar-ar-g2.ctb
- ar-ar-comp8.utb
- es-g2.ctb

*** Renamed
- de-de-accents.cti -> de-accents.cti
- de-de-g0.utb -> de-g0.utb
- de-de-g1.ctb -> de-g1.ctb
- de-de-g2.ctb -> de-g2.ctb
- de-ch-g0.utb -> de-g0.utb
- de-ch-g1.ctb -> de-g1.ctb
- de-ch-g2.ctb -> de-g2.ctb

*** Removed
- ar-fa.utb
- Es-Es-g1.utb

* Noteworthy changes in release 3.7.0 (2018-09-03)
This release implements major improvements for back-translation thanks
to concerted efforts by Bue Vester-Andersen, Bert Frees, Timothy Lee
and others. In particular the input/output positions are now correct
also for back-translation. There are new and improved Chinese Braille
tables and some long awaited improvements to UEB. The release also has
some code cleanups and documentation improvements.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/17?closed=1][the list of closed
issues]].

** New features
- Added a new opcode ~midendnumericmodechars~. Characters defined with
  this opcode can appear in the middle or at the end of a number
  without canceling numeric mode. Thanks to Bue Vester-Andersen.

** Bug fixes
- Fix another stack-based buffer overflow in input parsing reported by
  Henri Salo thanks to Christian Egli.
- Fix input/output positions for back-translation. Thanks to excellent
  bug reports and patches by Timothy Lee, Bert Frees heroically sat down and
  reworked the handling of the input/output positions for
  back-translation. This solves numerous issues with backward
  translation.
- The returned ~inlen~ and ~outlen~ now always match thanks to the
  above work on input/output positions by Bert Frees.
- Major improvements in the back-translation of capitalized words
  (~capsword~) in conjunction with punctuation and numbers. Thanks to
  Bue Vester-Andersen
- Fixed a problem in the back-translation of numbers in conjunction
  with punctuation and letters. Thanks to Rimas Kudelis and Bue
  Vester-Andersen
- Fix a buffer overflow in ~matchCurrentInput~. Thanks to Hongxu Chen
  for reporting and to Christian Egli for fixing it.

** Braille table improvements
- Danish grade 2 tables: Reduced hyphenation to only the hyphens
  necessary for correct Braille translation. Replaced the longer rules
  with hyphenation for better cursor positioning. Corrected some words.
  Thanks to Bue Vester-Andersen.
- New Chinese Mandarin Braille Codes (Grade 1) and (Grade 2) thanks to
  Sunian Loomee. The first one is for Chinese Common Braille, commonly
  known as the old Braille where a Chinese character is composed of
  three Braille Symbols, consonants, vowels and tones. The second
  table is for Chinese double spelling Braille, commonly known as the
  new Braille where Chinese character is composed of two Braille
  Symbols, consonants and vowels, ( the tones are included in vowels ).
- Major update to the Urdu tables thanks to Jake Kyle.
- Back-translation of numbers in Latvian, Polish, Portuguese, Serbian,
  and Swedish has been fixed thanks to Bue Vester-Andersen.
- Improvements to UEB such as handling of /BLT/, /BLVD/ and /LLC/,
  number sign placement, final-letter groupsign usage and final-letter
  back-translation thanks to Mike Gray.
- Significant changes to Bopomofo-based Chinese Braille. Among other
  things there is now complete the support of /CJK Unified Ideographs
  Extension A/ and some symbols were added for Nemeth. Thanks to
  Sponge Jhan and 黃偉豪. With this change we can now properly handle
  duoyinzi, Chinese words that have more than one pronunciation. The
  granularity of the cursor movement can now reflect positions of all
  Chinese characters.

** Other changes
- Added documentation of opcodes which were previously introduced as
  part of the UEB work. Thanks to Bue Vester-Andersen.
- Test suite improvements: In addition to checking the translation the
  tests now also check if the provided ~inlen~ is the same as the
  returned ~inlen~ and retry the test with a larger output buffer.
- Fix a problem in the Makefiles that prevented liblouis from being
  built with automake 1.16. This is fixed now thanks to a patch from
  Samuel Thibault.
- Removal of the code for the /scripting language/ for multipass
  opcodes. This code was originally introduced in 2012 but never
  documented. Consequently it was never used. Meanwhile the original
  code for multipass opcodes was much improved. So there is no more
  need for this (duplicate) code and we are removing it.
- The nightly snapshots of pre-built windows binaries are now built
  with UCS4 enabled.

** Deprecation notice
- None

** Backwards incompatible changes
- None

** New, renamed or removed tables
*** New
- zhcn-g1.ctb
- zhcn-g2.ctb
*** Renamed
- None
*** Removed
Tables that are only useful in the context of liblouisutdml were moved
there
- marburg.ctb
- marburg_edit.ctb
- nemeth.ctb
- nemeth_edit.ctb
- ukmaths.ctb
- ukmaths_edit.ctb
- wiskunde-translation.cti
- wiskunde.ctb

* Noteworthy changes in release 3.6.0 (2018-06-04)
This release contains the usual assortment of braille table
improvements, cleanups and bug fixes. The most prominent change is the
refactoring of the call APIs by Bert Frees that makes the code much
more manageable and solid and will help us in the future to evolve the
library.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/16?closed=1][the list of closed
issues]].

** New features
- Add metadata fields =name= and =display-name= to tables thanks to
  Bert Frees. The =name= contains a description of the table in the
  native language. =display-name= contains an English description.
- YAML test enhancements
  - You can now test both forward and backwards translation with in
    the same YAML file and for the same set of tables tests thanks to
    Bue Vester-Andersen. See the documentation for the
    ~bothDirections~ testmode.
  - Add =maxOutputLength= option in YAML tests.

** Bug fixes
- Fix a bunch of buffer overflow errors in table parsing thanks to
  Samuel Thibault and Christian Egli (CVE-2018-11410 and
  CVE-2018-11440).
- Fix input-output mapping of context rules thanks to Bert Frees.
- Fix back tracking with all caps words thanks to Bert Frees.
- Fix context rules with lookback thanks to Bert Frees.
- Fix a memory leak in default table resolver thanks to Timothy Lee.
- Fix an array out of bounds error which caused a crash on i386 thanks
  to Samuel Thibault.
- Fix numerous stack-based buffer overflow in table parsing reported
  by Henri Salo and Edward-L thanks to Christian Egli (CVE-2018-11577,
  CVE-2018-11683, CVE-2018-11684 and CVE-2018-11685).

** Braille table improvements
- Fix some forward- and back-translation errors in Unified French Grade
  2 thanks to André-Abush Clause.
- Updates to the Simplified-Chinese Braille Translation Table thanks
  to Roshanson
  - Added many polygraphs to distinguish different meanings of a word
  - Letter identifiers have been modified. In China's school for the
    blind, when many visually impaired students learn, the lowercase
    letters often do not have to mark the identifiers deliberately. So
    in this version, we this item has been deleted.
  - Fixed a bug in the braille code that revises the space and 0
- Updates to Bopomofo-based Chinese Braille Table thanks to Bo-Cheng Jhan
  - Redefine some Chinese words and phrases
  - Add various Nemeth symbols such as arrows and parenthesis
  - Complete the support of CJK Compatibility block
  - Fix the support of various parentheses, brackets, and braces
  - Minor fixes (kana rules, punctuation marks, Greek alphabets)
- New 8 dot computer braille table for Czech thanks to Jan Hegr.
- Fixes to Czech 6 dot table thanks to Jan Hegr
  - Fixed curly brackets representation
  - Fixed number sign representation
  - Added copyright sign
- Minor fixes to Hebrew thanks to Erez Kugler.

** Other changes
- Refactoring thanks to Bert Frees
  - Simplify the emphasis class handling by combining all related vars
    in a struct =EmphasisClass=
  - Simplify input/output buffer handling
  - Combine =emphasisBuffer= and =transnoteBuffer=
  - Group match related vars in a struct =PassRuleMatch=
  - Remove dead code
- Fixed many warnings thanks to Christian Egli

** Deprecation notice
- The =mode= parameter in =lou_dotsToChar= never had any effect and is
  now deprecated.
- In 2012 a new way to specify the test and action part in context and
  multipass opcodes was introduced. It was never documented and has no
  known usage in the wild. However it opens up the attack surface to
  the table parsing code. Therefore it is deprecated and will be
  removed in the next release.

** Backwards incompatible changes
- None

** New, renamed or removed tables
*** New
- cs-comp8.utb
*** Renamed
- None
*** Removed
- Cz-Cz-g1.utb

* Noteworthy changes in release 3.5.0 (2018-03-05)
This release has a number of Braille table improvements, cleanups and
meta data enhancements. The most prominent new feature however is
probably the much improved test coverage. This has helped in tracing
and fixing a number of long standing bugs.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/15?closed=1][the list of closed
issues]].

** New features
- The same name can now be used in more than one ~class~ rule. The
  effect is that both set of characters become part of that one class.

** Bug fixes
- Fix a regression in inputPositions thanks to Bert Frees
- Treat characters within the range ~compbrlStart~ and ~compbrlEnd~ as
  a special case. This fixes many if not most of the problems with
  cursor position and the ~compbrlAtCursor~ mode. Thanks to Dave Mielke.
- Fix ~swapdd~ opcode thanks to Bert Frees
- Fix negation of attribute matcher in multipass expressions thanks to
  Bert Frees

** Braille table improvements
- Add a display table that maps braille dots to brl/brf character set.
  For an in depth explanation see the corresponding [[https://github.com/liblouis/liblouis/issues/503][github issue]].
  Thanks to Rimas Kudelis
- Major Improvements to Unified French Grade 2 thanks to André-Abush
  Clause
- Fix braille number input for Greek Braille thanks to Dave Mielke
- Add a fix for "phad" according to UEB Rule 10.7.3 thanks to Anthony
  Tibbs
- Updates to the Urdu tables thanks to Jake Kyle from Compass Braille
- Updates to the Chinese braille table (~zh-tw.ctb~) thanks to
  Bo-Cheng Jhan
- ~IPA.utb~ now contains a more complete list of phonetic symbols,
  including some that might conflict with other tables. For this
  reason it is not suitable for inclusion in other tables. A separate
  table ~IPA-unicode-range.uti~ has been added for this
  purpose. Thanks to Ludovic Oger.
- The Mongolian table has been improved and there is now also support
  for grade 2 thanks to Tsengel Maidar.
- Minor updates to the Danish tables thanks to Bue Vester-Andersen
- Fix back translation of numbers in Dutch, Finnish and Canadian
  French, thanks to Leonard de Ruijter.
- New table for Ukrainian thanks to Sergiy Moskalets.

** Other changes
*** Improved documentation
- Extend the documentation on multipass opcodes. Thanks to Dave Mielke
  and Christian Egli.
- Remove the deprecation note of the '=' dots operand. While there are
  still problems with back-translation we will not remove support for
  it. See also the discussion in the [[https://github.com/liblouis/liblouis/issues/500][github issue]].

*** Improved meta data information in tables
The meta data in the tables such as locale, contraction grade, etc has
been improved and is now also used when testing from a YAML test.
Thanks to Bert Frees.

*** Major overhaul of the YAML test suite
**** Support for proper testing of cursor positions
Due to problems in the cursor position computation the YAML test
suite was improved to support proper testing of cursor position also
in combination with input, output position and modes. In essence all
of the liblouis API is now supported and can be tested via the YAML
tests. Thanks to Christian Egli.

**** Support for table selection via meta data query
The tables to be tested can now be specified via a meta data query in
addition to specifying them by filename. See the documentation for
more details. Internally the YAML tests have been split up into tests
that test the braille translation for a particular locale (now located
in ~tests/braille_specs~) and tests that check a specific feature of
liblouis. Thanks to Bert Frees.

** Deprecation notice
None

** Backwards incompatible changes
- The translation mode ~comp8Dots~ has been removed as it was never
  really implemented anyway
- Support for the ~pass1Only~ flag has now been removed. Thanks to Bue
  Vester-Andersen.
- The old UEB tables ~UEBC-g1.ctb~ and ~UEBC-g2.ctb~ have been removed
  as the have been superseded by ~en-ueb-g1.ctb~ and ~en-ueb-g2.ctb~.
- The french tables ~fr-2007.ctb~, ~fr-fr-g1.utb~, ~fr-fr-g2.ctb~,
  ~fr-ca-g1.utb~ and ~fr-ca-g2.ctb~ have been removed. Use
  ~fr-bfu-comp6.utb~ for 6 dots literary, ~fr-bfu-comp8.utb~ for 8
  dots computer and ~fr-bfu-g2.ctb~ for contracted braille instead.

** New, renamed or removed tables
*** New
- IPA-unicode-range.uti
- mn-MN-g2.ctb
- uk.utb
*** Renamed
- mn-MN.utb -> mn-MN-g1.utb
*** Removed
- fr-2007.ctb
- fr-ca-g1.utb
- Fr-Ca-g2.ctb
- fr-fr-g1.utb
- Fr-Fr-g2.ctb
- UEBC-g1.ctb
- UEBC-g2.ctb

* Noteworthy changes in release 3.4.0 (2017-12-04)
This release brings together a lot of work by lots of different
people. Probably the most prominent fix is the work on output
positions by Bue and Bert. NVDA should benefit from this. Then there
are new and massively improved tables like the Lithuanian 6-dot table
by Rimas or the improved back-translation for French by Michel and
André-Abush to name just a few. There are too many contributors to
name them here, thanks to them all.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/14?closed=1][the list of closed
issues]].

** New features
- Add support for ~inputPos~ and ~outputPos~ checking in
  ~lou_checkyaml~ thanks to Bue Vester-Andersen. See the manual for
  details and examples.
** Bug fixes
- output positions (~outputPos~) are now calculated based on input
  positions (~inputPos~) thanks to Bert Frees. This avoids a whole
  class of bugs that previously plagued the output positions. This fix
  also obviates the need for the ~pass1Only~ flag. See below for the
  deprecation notice.
** Braille table improvements
- Addition of Nemeth and Kangxi radical characters and other
  improvements to Chinese braille (~zh-tw.ctb~) thanks to Bo-Cheng
  Jhan and 黃偉豪.
- Improvements to the Spanish chardefs table thanks to Luis Lorente
  Barajas and Simon Aittamaa.
- Fixed a lowercase ó in Spanish first reported for NVDA thanks to
  Sukil Etxenike.
- New Norwegian 6-dot display braille table for Braillo embossers
  thanks to Lars Bjørndal
- Added a bunch of whitespace-like codepoints as spaces thanks to
  Rimas Kudelis
- Added Lithuanian 6-dot table thanks to Rimas Kudelis.
- Addition of more characters to the French tables thanks to Samuel
  Thibault
- Improvements to the Hungarian tables thanks to Attila Hammer
- Improvements to the Mongolian tables thanks to Tsengel Maidar
- Fix some math signs in Czech Braille (~cs-chardefs.cti~). Thanks to
  Christian Herden of ViewPlus for reporting this.
- Updates to the SEB British Braille Tables thanks to Paul Wood
- Massive improvements to French back-translation thanks to Michel
  Such and André-Abush Clause
** Other changes
*** Improved documentation
- Bue Vester-Andersen added some notes about back-translation and
  documented all possible values of the ~mode~ parameter. Also the
  description of ~decpoint~ and ~litdigit~ was improved.
- The ~match~ opcode is now documented thanks to Mike Gray and
  Christian Egli.

*** lou_maketable
Numerous bug fixes and performance enhancements thanks to Bert Frees

*** Code refactoring
Many global variables have been removed thanks to Bert Frees

*** Code formatting
Thanks to clang-format There is now a uniform coding style over the
whole code base

*** Fix broken NMakefile
Thanks to Davy Kager building with nmake should work again

** Deprecation notice
The ~pass1Only~ flag has been deprecated. Its use should be avoided,
and it will be completely removed from the code in the next version of
Liblouis. When using the ~pass1Only~ flag in this release you will get
a warning.

** Backwards incompatible changes
None

** New, renamed or removed tables
*** New
- no-no-braillo-047-01.dis
- lt-6dot.utb
*** Renamed
None
*** Removed
None

* Noteworthy changes in release 3.3.0 (2017-09-04)
This release brings a slew of Braille table improvements, fixes a
number of security related bugs and introduces a new tool to generate
liblouis Braille tables based on a corpus of know good Braille
translations. For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/13?closed=1][the list
of closed issues]].

** New features
*** maketable tool
A new tool ~lou_maketable~ enables the creation of tables based on a
corpus of known good Braille translations. This has huge potential to
simplify table maintenance for tables that have so far been dominated
by large exception lists. Thanks to Bert Frees.
*** Meta data query API
A new API and a corresponding command line tool to query table meta
data thanks to Bert Frees

** Bug fixes
*** Back translation
- UEB grade 2
  - Fix back-translation of whole word contractions followed by other
    contractions thanks to James Teh.
  - Fix back-translation for contractions followed by punctuation
    thanks to James Teh.
*** Security
- Fix a number of CVEs (illegal address access, buffer overflow and
  use-after-free or in terms of CVEs: CVE-2017-13738, CVE-2017-13739,
  CVE-2017-13740, CVE-2017-13741, CVE-2017-13742 and CVE-2017-13744)
  thanks to Mike Gorse.
- Fix CVE-2017-13743 thanks to Christian Egli.

** Braille table improvements
- New table for Croatian grade 1 Braille thanks to Zlatko Sobočan.
- Fixes and tests for Slovak Braille thanks to Simon Aittamaa
- Numerous fixes in the character definitions of the Spanish tables
  thanks to Simon Aittamaa
- Unified French 6 dots and 8 dots improvements for back-translation
  thanks to Michel Such
- Updates to the Chinese braille table thanks to Coscell Kao
- Updates to Nemeth character definitions thanks to Attila Hammer
- The Hungarian tables now conform to the new 2017 standard thanks to
  Attila Hammer

** Backwards incompatible changes
- The constant ~otherTrans~ has been removed in both the C API and the
  corresponding Python bindings.
- The constants ~ucBrl~, ~noUndefinedDots~ and ~partialTrans~ have
  different values now in both the C API and the corresponding Python
  bindings.

** New, renamed or removed tables
*** New
- hr-g1.ctb
*** Renamed
- hr.ctb -> hr-comp8.utb
*** Removed

* Noteworthy changes in release 3.2.0 (2017-06-06)
Aside from the usual improvements to Braille tables this release
focuses on improving the internal infrastructure. Numerous bugs have
been fixed, the CI infrastructure also checks mingw builds now and MSVC
compatibility has been massively improved. For a detailed list of all
the changes refer to [[https://github.com/liblouis/liblouis/milestone/10?closed=1][the list of closed issues]].

** Bug fixes
- Fix capsnocont opcode. Also mark capital letters with capsletter
  symbol when capsnocont is defined but no begcapsword indicator is
  defined. Thanks to Bue Vester-Andersen.
- Fix the syllable opcode. It had been broken under some circumstances
  since 3.0. Thanks to Bert Frees and Christian Egli.
** Other changes
- Fix building of Python bindings when cross-compiling. Thanks to
  Chris Brannon
- lou_checkyaml is now only installed if libyaml is available. Thanks
  to Christian Egli
- Major internal changes to improve MSVC compatibility. Thanks to Davy
  Kager
- Enhance documentation on usage of display tables in particular
  in conjunction with Unicode dot patterns. Thanks to Bert Frees
** Braille table improvements
- Improvements to the Swedish 8-dots table (~se-se.ctb~) thanks to
  Kevin Derome
- Improvements to the Simplified-Chinese Braille table thanks to
  Roshanson
- Fixes for the International Phonetic Alphabet Braille table thanks
  to Ludovic Oger
- Added more Unicode symbols (fractions and not equal) to the UEB
  tables. Thanks to Paul Wood and James Bowden.
- Fixes to UEB grade 2 (en-ueb-g2.ctb) thanks to Mike Gray.
- Vastly improved Danish tables thanks to Bue Vester-Andersen.
  - New literary tables for 6 dots, mainly for embossing (no
    back-translation).
  - Improved back-translation in 6 dots tables, all grades.
  - New support for many Unicode characters in all 6 dots tables.
  - Strengthened internal tests to prevent breaking of tables due to
    changes in the code.
  - Fixed 8 dots tables which were broken in the previous version.
- New Braille tables for Sinhala script thanks to Ashoka Bandula
  Weerawardhana.
- New Hungarian grade 2 Braille table thanks to Attila Hammer.
- Improvements to UEB in particular to symbols specified mostly on the
  Appendix 3 (Symbols List) from the Rules of Unified English Braille
  Second Edition 2013 document thanks to Victor Montalvão.
- Improvements to Persian 8 dot computer Braille table thanks to
  Mohammadreza Rashad.
** Backwards incompatible changes
- The old Greek table gr-gr-g1.utb is gone. Use el.ctb instead
- The doctests are gone. They have been superseded by the YAML tests.
- The internal API which was previously in louis.h has been made
  internal, i.e. the file is renamed to internal.h and the function
  names are prepended with underscores ('_').

** New, renamed or removed tables
*** New
- sin.cti
- sin.utb
- hu-hu-g2.ctb (new)
- da-dk-6miscChars.cti (new)
- da-dk-g16-lit.ctb (new)
- da-dk-g26-lit.ctb (new)
- da-dk-g26l-lit.ctb (new)
*** Renamed
- gr-gr-g1.utb (removed and replaced by el.ctb)
*** Removed
- da-chardefs6.cti
- da-dk-common6.uti
- da-dk-g26-patches.cti
- da-dk-g2core.cti
- da-dk-nocaps.uti

* Noteworthy changes in release 3.1.0 (2017-03-06)
An influx of new contributors have made sure that liblouis continues
to improve. Back translation has seen major improvements, there are
some additional modes to help screen readers, for many tables meta
data has been added, the Python bindings are more robust, Windows
support has been improved, the YAML test suite has been generalized
and as usual new and improved braille tables have been included. On
the licensing front we managed to get almost all tables re-licensed to
LGPLv2.1+.

** New features
*** Meta data
Most of the translation tables now contain meta data. This makes them
discoverable. Programs can use the lou_findTable function to find a
table based on a query.

*** noUndefinedDots mode
Add a noUndefinedDots mode to disable the output of dot numbers when
back-translating undefined patterns. Thanks to James Teh.

When back translating input from a braille keyboard cell by cell, it is
desirable to output characters as soon as they are produced.
Similarly, when back translating contracted braille, it is desirable to
provide a "guess" to the user of the characters they typed. To achieve
this, liblouis needs to have the ability to produce no text when
indicators (which don't produce a character by themselves) are not
followed by another cell. This works already for indicators liblouis
knows about such as capital sign, number sign, etc., but it does not
work for indicators which are not (and cannot be) specifically defined
as indicators. For example, in UEB, dots 4 5 6 alone produces the text
"\456/". Setting the noUndefinedDots mode suppresses this dot number
output.

*** partialTrans mode
Add a partialTrans mode to specify that back-translation input should
be treated as an incomplete word. Thanks to James Teh.
  
If this mode is set, rules that apply only for complete words or at
the end of a word will not take effect. This is intended to be used
when translating input typed on a braille keyboard to provide a rough
idea to the user of the characters they are typing before the word is
complete.

*** YAML test framework
The YAML framework has been extended and is much more useful now. You
can test multiple tables within one YAML file, you can define test
tables directly inline and you can test multiple tables using the same
test data. Refer to the documentation for the details.

If really not wanted the YAML tests can be disabled by specifying
~configure --without-yaml~.

** Bug fixes
- Fixes implicit declaration of 'pattern_check' thanks to  Reiner Dolp
- Fix a stackoverflow crash on applications with smaller stack size.
  Thanks to Victor Montalvão.
- Fix the \v escape sequence. Thanks to Davy Kager.
- The Python bindings now give a helpful error if liblouis has been
  compiled with a different character size than Python. Thanks to Matt
  Wenn.
- Massive bug fixes in multipass rules. Dave Mielke has done a
  tremendous job improving the multipass machinery also in the
  context of back-translation. Where needed nofor/noback has been
  added to the multipass rules.

** Other changes
- Improvements to the Emacs mode for editing liblouis tables thanks to
  Christian Egli
- Documenting lou_charSize thanks to Reiner Dolp
- Support for relative table paths in the tests. This will make sure
  you always know which table a test actually uses.
- Infrastructure to build windows binaries in a Docker container,
  thanks to Bert Frees

** Braille table improvements
- UEB improvements, thanks to Mike Gray
  - Fixed apostrophe and back translation
  - Added rules for Unicode apostrophe handling
  - Improvements to UEB and Nemeth math
- Complete overhaul of Lithuanian 8-dots table, thanks to Rimas
  Kudelis
- New Urdu 6 Dot Grade 1 and 2 Braille tables thanks to Jake Kyle
- Improvements to Italian 8 dots computer braille, thanks to Simone
  Dal Maso.
- New table ~unicode-braille.utb~ that helps to back translate braille
  input to Unicode braille output, thanks to Leonard de Ruijter.
- Improvements to the Chinese braille table thanks to Coscell Kao.
- New Turkish braille table for grade 1 that should replace the
  old ~tr.ctb~ table, thanks to Arend Arends.
- New Persian grade 1 table and 8-dots computer table thanks to
  Mohammadreza Rashad.
- New table for the International Phonetic Alphabet thanks to Ludovic
  Oger
- Fixes for the French 6 and 8 dots tables thanks to Michel Such. Some
  errors have been fixed and many Unicode characters have been added.
- Add an extended 8-dot computer braille table for U.S. English thanks
  to Davy Kager. The table is tailored for use on Windows (CP-1252)
  and uses dot patterns from Windows screen readers, but should be
  useful on other platforms too.
- New Greek table that is better than the existing Greek Grade 1
  Braille Table (gr-gr-g1.utb) thanks to Dave Mielke.
- Improved number back-translations on fr-fr-g1 and vi-g1 tables
  thanks to Victor Montalvao.
- New Chinese Braille table for use in the mainland of China thanks to
  Kaifang Bao of RejoinTech.
- The Black Circle character is commonly used for displaying password
  characters. The absence of its definition leads to users not being
  able to know how many characters were typed in such fields. This has
  been improved for many tables thanks to Victor Montalvao.

** License changes
- DocArch has agreed to re-license their tables, so we have 8 more
  tables under the LGPLv2.1+.

** Backwards incompatible changes
- The naming in the YAML test framework has changed slightly from
  `tables:` to `table:`.

* Noteworthy changes in release 3.0.0 (2016-07-14)
This is the biggest release of liblouis in years. The major news are
that we now have proper support for UEB and secondly that liblouis is
now licensed under [[https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html][LGPLv2.1+]].

In order to support UEB the internals of liblouis have seen a major
rewrite. New Opcodes have been added to support the requirements for
proper UEB for example for emphasis handling or to handle proper
translation of numbers. Changes to the opcodes are described in the
documentation. Some of these changes are not backwards compatible. All
tables that come with liblouis have been migrated. If you have private
tables look at the section on upgrading from previous versions in the
[[https://github.com/liblouis/liblouis/wiki/Emphasis-Opcodes#upgrade-from-previous-versions][wiki]].

This release also changes the C API. External applications will have
to adapt the way they call liblouis. In particular the typeform
parameter has changed.

The license of the library and most of the tables has been changed to
LGPLv2.1. For a detailed list which tables are still in the process of
migrating the license refer to the [[https://github.com/liblouis/liblouis/wiki/Licensing-of-liblouis-tables][wiki page about the license change]].

** New features
- Numerous features to support UEB properly. Thanks to Mike Gray,
  William Freeman, Davy Kager, Keith Creasy and the American Printing
  House for the Blind for sponsoring this work.
  - support the many emphasis classes needed for UEB.
  - support translation of numbers according to the rules of UEB.
  - Capitalization is now handled just like emphasis.
  - support for numeric mode
- UTF-8 support for all tools thanks to Christian Egli.
- The YAML tests now allow for an optional test description. See the
  documentation for more details.
- Add ~lou_checkTable~ and ~lou_getTypeformForEmphClass~ to the C API
  and to the Python bindings
** Bug fixes
- Stop buffer overrun in ~lou_getProgramPath~, and also free memory
  after usage. Thanks to Michael Curran.
** Other changes
- The license of the library and most of the tables has been changed
  to [[https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html][LGPLv2.1+]].
- Improvements to the test suite:
  - Output is printed to ~stderr~. This helps with locating errors when
    testing with the YAML test suite.
  - typeform is included in output.
** Braille table improvements
- Improved Finish 6-dot braille thanks to Jukka Eerikäinen
- Improvements to the Chinese braille table thanks to Coscell Kao
- Improvements to Mongolian thanks to Tsengel Maidar and Sreeja Param
- Added new Slovak tables based off the official Slovak braille
  standard thanks to Peter Vagner
- Changes to the Norwegian tables. There are now three Norwegian 8-dot
  tables
  - ~no-no-comp8.ctb~: Norwegian 8-dot computer braille table
  - ~no-no-8dot.utb~: Norwegian 8-dot braille table
  - ~no-no-8dot-fallback-6dot-g0.utb~: Norwegian 8-dot braille table
    with uncontracted 6-dot fallback
- Changes to the Dutch tables
  - Conforms better to the standard.
  - ~nl-BE-g1.ctb~ renamed to ~nl-BE-g0.utb~
  - ~nl-NL-g1.ctb~ renamed to ~nl-NL-g0.utb~
- Improvements to Danish tables: Added grade 2 with limited
  contractions to 6 and 8 dots. Corrected contraction of many words.
  - Renamed:
    - ~da-ansi8.dis~ -> ~da-dk-octobraille.dis~
    - ~da-dk-g16.utb~ -> ~da-dk-g16.ctb~
    - ~da-dk-g18.utb~ -> ~da-dk-g18.ctb~
    - ~hyph_da_DK.dic~ -> ~hyph_brl_da_dk.dic~
  - Removed: ~da-dk-g28caps.cti~, ~da-dk-g28-patches.cti~ and
    ~da-chardefs8.cti~
** Backwards incompatible changes
- The json based harness test suite has been removed as its
  functionality has been superceded by the YAML tests. Please use
  these from now on.
- A number of opcodes to handle emphasis have been renamed.
- The C API regarding the typeform parameter has changed.

* Noteworthy changes in release 2.6.5 (2015-12-1)
This minor release introduces new tables (Mongolian and Norwegian 8
dot) and new features to the tracing tool. But the most exiting news
about this release is probably the fact that 12 developers have
contributed to it, showing how widely used liblouis is and how
actively the development progresses.

** New features
- A DEF file is now generated automatically for the windows builds.
  Thanks to Christian Egli
- lou_trace supports backtranslation now. Thanks to Bert Frees

** Bug fixes
- Fix a bug in the findtable code. Thanks to Michael Katzmann for the
  report.
- Fix some compile time warnings on Windows, thanks to Bue
  Vester-Andersen.
- Fixes to the logging code by Arend Arends.

** Other changes
- Add test data for EUB symbols, thanks to Paul Wood
- Clean up dead code i.e. remove support for (undocumented) nobreak
  opcode. Thanks to Bue Vester-Andersen.

** Braille table improvements
- New Mongolian table thanks to Tsengel Maidar and Sreeja Param.
- Improvements to the Chinese braille table thanks to Coscell Kao.
- Massive improvements to Norwegian, thanks to Lars Bjørndal, Ammar
  Usama and Jostein Austvik Jacobsen. They added a 8 dot table and
  lots of test data.
- Improvements to Hungarian, thanks to Attila Hammer

* Noteworthy changes in release 2.6.4 (2015-08-31)
This is a minor release in terms of features. But in terms of test
coverage and stability it is a vast improvement over previous versions
of Liblouis. The new YAML based test suite contains more than a
million of validated translations. Every change in Liblouis is tested
against this corpus ensuring the change doesn't break anything.

** New features
- YAML based harness tests. Harness tests can now be written in simple
  YAML notation and they are integrated with the normal `make check`
  command. They can be used for both ucs2 and ucs4 and no Python is
  required. Thanks to Christian Egli.

** Bug fixes
- Use a separate gnulib instance for the library and the tools. Use
  the strndup module to avoid build problems on windows.
- Fix a problem with the nocross opcode when used in combination with
  the opcodes nocont and compbrl, thanks to Bue Vester-Andersen.
- Fix a problem with the decoding of the harness test files. Thanks to
  Bert Frees.
- Fix numerous problems in the way braille indicators are handled.
  There is now a safe version of the checkAttr function which makes
  sure that no attributes are checked beyond the boundaries of the
  currentInput. This fixes the random behavior with tests where the
  emphasis extends to the end of the input string. Thanks to Christian
  Egli.

** Other changes
- if found use texi2any to build the documentation, thanks to Martin
  Michlmayr.
- Fix permissions of Korean tables, thanks to Peter Lundblad.
- Update the windows build instructions, thanks to Bue
  Vester-Andersen.

** Braille table improvements
- Improvements to Hungarian, thanks to Attila Hammer
- Improvements to Hungarian 8 dot and Serbian grade 1, thanks to
  Zvonimir Stanecic

* Noteworthy changes in release 2.6.3 (2015-06-01)
Given the release number you might think this is only a minor release.
However looking at the number of developers who contributed to it and
the number of pull requests and issues that were solved this turns out
to be a very impressive and solid release. Most prominently we have a
new function to discover tables based on meta data in table headers.
Also makeinfo is no longer required to build liblouis. And lastly we
have numerous improvements in Braille tables such as Korean,
Vietnamese and UEB to name just a few.

** New features
- [beta] The new function lou_findTable can be used for table
  discovery based on meta data in table headers. Thanks to Bert Frees.
- The Python API now has a new function to check tables aptly named
  ~checkTable~. Thanks to Davy Kager.

** Bug fixes
- Fixed a problem in resolveTable when using a Java resolver, thanks
  to Bert Frees

** Other changes
- The build dependency on makeinfo is now optional. If it is not
  installed we simply do not build the documentation.

** Braille table improvements
- Improvements to Bengali, Devanagari, Kannada, Gujarati, Malayalam,
  Telugu and Oriya, thanks to Sreeja Param
- Corrections and improvements made to en-GB tables thanks to Paul
  Wood
- Vast restructuring to Korean tables. In 2006 the Institute for Korean
  Braille modified some dots in Korean Braille. Specifically, some
  punctuation dots are now based on English. To accommodate this change
  and to retain the old tables, the Korean table set was revised as
  follows:
  - Added three files: ko-chars, the Korean characters dictionary, and
    rules for g1 and g2.
  - ko-g1 and ko-g2 are now interface files that includes needed
    files.
  - Added three files for Korean Braille 2006 revision along with a
    test harness.
- New table for Polish 8 dot computer braille. Thanks to Karol Pecyna.
- New table for Vietnamese 6 dot. Thanks to Harri Pasanen.
- Corrections and improvements made to UEB tables thanks to Paul Wood
  - Typeform passage indicators
  - Degree sign
  - Dash signs
  - Math signs
  - Accent modifiers
  - Accented letters

* Noteworthy changes in release 2.6.2 (2015-03-02)
This release, which was mostly pushed out the door by Bert and Mesar,
fixes a long standing emphasis bug, adds more functionality to the
harness test suite and improves, as usual, on Braille tables. Notably
there is a brand new finish table backed by Celia.

** New features
- Harness tests now can test for typeform differences.

** Bug fixes
- Fix for emphasis bug, thanks to Michael Gray

** Braille table improvements
- Correction to comments in Norwegian generic tables, thanks to Lars
  Bjørndal
- Corrections to dot patterns in no-no-g0.utb thanks to Lars Bjørndal
- Corrections and additional test cases for Hungarian grade 1, thanks
  to Hammer Attila.
- New 6-dot table for Finnish thanks to Jukka Eerikäinen from
  Celia. The existing tables for Finnish were 8-dot, but there is an
  official specification only for 6-dot braille in Finnish.

* Noteworthy changes in release 2.6.1 (2014-12-01)
This release focuses on table and documentation improvements. The
documentation has been restructured to cater to people starting with
writing Braille tables. End users will see improvements to Braille for
Danish, Dutch, Hungarian, Irish and UK English.

** New features
*** New Braille tables
- New grade 1 and grade 2 Gaeilge tables implementing the 2014 UIB
  standard. Including tests, thanks to Ronan McGuirk, Mesar Hameed.

** Braille table improvements
- Updates and correction to Hungarian braille tables, thanks to Hammer
  Attila.
- Correction to English UK grade 2 braille tables and new tests,
  thanks to Paul Wood, Mesar Hameed
- Vastly improved Danish tables thanks to Bue Vester-Andersen
  - back-translation, both in 6 dots grade 2 and 8 dots grade 2.
  - Better handling of dash, slash, and other punctuation within words
    in 8 dots grade 2.
- New table for Dutch (Netherlands) thanks to Henri Apperloo from CBB

** Bug fixes
- fix a compiler warning in the logging code. Thanks Peter Lundblad
  for reporting it and Michael Whapples for fixing the problem.

** Documentation updates
- The documentation has been restructured to be more beginner friendly
  and a short introduction to translation table writing has been
  added. Thanks to Joseph Lee and Christian Egli

** Other changes
- When compiling with mingw or cygwin resulting dll is liblouis.dll.
- runHarness.py: add new output format, compact output mode suitable
  for grepping.

** Backwards incompatible changes
- Deleted ga.ctb now superseded by ga-g1.utb and ga.g2.ctb.
- Nl-Nl-g1.utb has been removed. It is superseded by nl-NL-g1.ctb.
- nl-be-g1.utb has been removed. It is superseded by nl-BE-g1.ctb.

* Noteworthy changes in release 2.6.0 (2014-09-01)
This is the first release by the new maintainer team. A lot of work by
people from across the community contributed to this release. There
are massive additions and updates to the Braille tables (e.g.
Afrikaans, Hebrew, many Indian languages, Korean) and also changes to
the C API to enable call backs for error messages and warnings.

** New features
*** New Braille tables
- Tables for Afrikaans, Cherokee, Hawaiian, Maori, Sotho and Tswana
  were donated by Greg Kearney. Afrikaans, Cherokee, Maori and Hawaiian
  all are grade 1 tables and with the exception of Cherokee were
  derived from World Braille Usage 2013. The Cherokee was taken from
  the specification published at www.cbtbc.org/cherokee/.
*** Logging callback
There is now a callback system in place to get error messages and
warnings. This can be used from programs that use liblouis to log
warnings for example.

** Bug fixes
- fix back translation problems when word gets split in unusual places
  causing back translation of whole words for example K5 back
  translates to Knowledgeen, M>k back translates to Moreark, and M5
  back translates to Moren.  This caused over 8400 extra back
  translation errors in en-us-g2 and 5000 in en-ueb-g2. Thanks to Ken
  Perry.
- Fixed bug to prevent removal of \xffff between largesign rules. This
  solves a Liblouisutdml bug where \xffff is used as a segment
  delimiter.
- Fixed a bug in back translation, when a letsign was encountered, the
  letsign was being applied beyond the element it applied to.
- Fix memory leaks in the default table resolver introduced in the
  previous release.
- Fixes to the build system by Simon Aittamaa

** Braille table improvements
- Major improvements to Indian tables thanks to the Indian National
  Institute for Visually Handicapped, in particular Dipendra Manocha,
  Mesar Hameed, Dinesh Kaushall and Sreeja Parameswaran:
  - Corrected opcodes for letters, punctuation marks, digits, signs
    etc.
  - Updated braille codes according to prescribed braille codes for
    each Unicode character by the Braille Council of India for all
    Indian languages.
  - defined rules for dealing with Nukhta character in Hindi table
  - defined rule to insert dot-1 between consonant followed by full
    vowel character in all Indian Languages
  - defined rules for shifting of halant character before the
    consonant. This character is placed after the consonant in normal
    typing but need to be before the consonant in braille. This rule
    is applicable for all Indian languages.
  - defined rules for two conjunct characters "ksha and gya" used in
    all Indian Languages for which there are specific codes in
    Braille.
- New Hebrew table that is based on the new unified Hebrew Braille
  code standard that was put together on January 2014 after a
  conference with all of the specialists in this field in Israel. It
  includes improved representation of Hebrew letters, special letters
  that are called Nikud, and punctuation symbols. The old Braille
  standard is not relevant any more. Thanks to Adi Kushnir.
- UEB table fixes: Fix ity contraction, fixed the missing end word
  contraction ;n ;d sign 46. thanks to Ken Perry.
- Fix for Norwegian where letsign is affecting some extra characters
  thanks to Lars Bjørndal
- Much improved hyphenation for Norwegian thanks to Lars Bjørndal
- Korean Grade 2 now includes support for reading English text using
  grade 2.
- en-us-g1.ctb and en-ueb.g1.ctb are now able to display 8 dot Unicode
  braille.

* Noteworthy changes in release 2.5.4 (2014-03-03)
This release contains nine months worth of braille table improvements
for example for Danish, UEB, en-us, Nemeth, Bulgarian, Slovenian and
many more. Also there are fixes to the core for table path resolving
and back-translation.

** New features
   - Added function lou_registerTableResolver for plugging in a table
     resolver callback from your host language.

** Bug fixes
   - Fixed ENDSEGMENT indicator in computer Braille thanks to John
     Boyer.
   - Emphasized words should now be contracted consistently thanks to
     John Boyer.
   - Fixed several problems with back-translation. A slash within a
     number and strings such as 5-inch-diameter and 25-year-old-man
     should now back-translate correctly. Thanks to John Boyer.
   - Fixed a problem with syllable opcode. Thanks to John Boyer.
   - Fix warnings with gcc 4.8.2. Thanks to Peter Lundblad.
   - When a table is specified with an absolute or relative path, the
     "includes" in that table will now work as expected, meaning files
     in the same directory will be found.

** Braille table improvements
   - fr-bfu-comp8.utb: corrections, zero was wrongly displayed in some
     instances.
   - en-us-g2.ctb, en-ueb-g2.ctb: Fixes for that's, can't and s'
     thanks to Ken Perry.
   - en-us-g2.ctb: Fix for back-translation of things like
     http://address.com, words including after, capsigns. thanks to
     Ken Perry.
   - Further corrections and testcases to the Hungarian tables thanks
     to Hammer Attila
   - Fixed letter sign in en-us and en-ueb tables. Thanks to John
     Boyer and Ken Perry.
   - UEB Fixes thanks to Mesar Hameed, Ken Perry and Joseph Lee:
     - chardefs - correct title and fixed a long standing bug
       where dots 46 was inserted between letters (especially for web
       addresses).
     - Fix problem with at sign.
     - Removed section of accented letters, that were left behind from
       US table.
     - Added todo for accents, to define according to the formal docs.
     - Corrected mathematical forall symbol.
     - Modified emphasis dot combinations to follow UEB standard.
     - Corrected the display of period when used as a midword.
     - Ensure 'inin' is correctly back-translated in words such as
       asinine, feminine and others.
   - Bulgarian bg.ctb: updated to meet modern standards (added Latin
     letters, corrected punctuation/mathematical symbols, misc typos).
     Thanks to Rumiana Kamenska
   - en-gb-g1.utb: Fixes thanks to Paul Wood
   - Fix for the lich sign in the German tables. Thanks to Halim
     Sahin.
   - Nemeth improvements thanks to John Boyer.
     - Spaces in nemethdefs.cti were changed to unbreakable spaces.
       This was done so that Nemeth expressions would not be broken
       between lines.
     - The number sign is now inserted between the minus sign and the
       number at the beginning of an expression. Some problems with
       pass2 opcodes have also been corrected.
   - The Esperanto table has additional punctuation characters and a
     test harness. Thanks to Aaron Cannon.
   - Added missing symbols to the US English BRF display table. Thanks
     to Aaron Cannon.
   - Improvements to the Slovenian table and a new Slovenian eight dot
     computer table provided by Jožef Gregorc.
   - Fixes to the Norwegian tables thanks to Lars Bjørndal
     - Fixes for less than / greater than.
     - Add entries for URLs, domains and file names.
   - Added ne.utb, an alternative Nepali braille table. One of ne.utb
     or ne.ctb will be removed/merged in a future version. Keeping
     both for the time being so that users can test and give feedback
     on which is most correct. Thanks to Him Prasad Gautam, and Mesar
     Hameed
   - Much improved danish grade 1 and grade 2 6 and 8 dot braille,
     thanks to Bue Vester-Andersen and Mesar Hameed

** Backwards incompatible changes
   - Delete the table chardefs-ueb.cti as these rules are now provided
     by en-ueb-chardefs.uti

** Invisible changes
   - Refactoring in compileTranslationTable.c: separated more clearly
     the compilation from the table resolving, removed duplicate code,
     etc.

* Noteworthy changes in release 2.5.3 (2013-06-21)
** New features
*** New Braille tables
    - Korean grade 1 and grade 2 thanks to Joseph Lee
    - U.K. English 8 dot computer braille table thanks to David
      Reynolds
    - New Russian literary and computer braille tables thanks to Igor
      B. Poretsky. These replace the older Russian tables which are
      left for backwards compatibility.
    - New hyphenation dictionary for Russian thanks to Igor B.
      Poretsky.
    - Updated hyphenation tables for the Norwegian language (nynorsk
      and bokmål) thanks to Lars Bjørndal.
    - New hyphenation dictionary for Esperanto thanks to Aaron Cannon.
    - New Esperanto grade 1 table, using the x system for accented
      letters, thanks to Aaron Cannon.

*** runHarness.py: 
    Accept filename globs on the commandline to run specific harness files.
    In tests/harness, one can do make <filename> or make runall
    Removed from make check because these checks are checking the validity
    of our tables, rather than validity of the code.

** Braille Table Improvements
   - da-dk-g2.ctb, mostly rewritten to use nocross and hyphenation
     table.
   - Most tables: removed the default collapse whitespace statements,
     if you need to compress whitespace, consider adding compress.ctb
     to the list of tables when processing.
   - Corrections to Unified English Braille Code (Grade 1 and 2),
     thanks to Joseph Lee
   - Corrections to apostrophes in the Computer Spanish 8 dots Braille
     table (Es-Es-G0.utb). Thanks to Juan C. Buno.
   - Corrections for double angle quotation marks and emphasis marks
     in the Norwegian Grade 0 Braille Table. Thanks to Knut Arne
     Bjørndal.
   - Fixes for a minor problem regarding the noletsign in Norwegian
     contracted braille. Thanks to Lars Bjørndal.
   - Corrections to the Italian table thanks to Igor B. Poretsky.
   - Corrections to the Hungarian grade 1 table thanks to Hammer
     Attila
   - Corrections to English, U.S. Grade 2 (ABAE) table. Thanks to Ken
     Perry for reporting the bug and John J. Boyer for fixing it.
   - Further reorganization of the tables to remove duplication. Move
     litdigit opcode common parts and include where needed.
   - Removed obsolete en-us-g1.utb, which has been replaced by
     en-us-g1.ctb.
   - Added dictionary harness tests for: en-ueb-g2.ctb, en-us-g2.ctb.
   - Corrections to Nemeth character definitions thanks to Neil
     Soiffer.
   - Corrections to the Esperanto table thanks to Aaron Cannon.

** Bug Fixes
   - Cursor position calculation is now based on the same code that
     calculates inpos and outpos. This probably solves a number of
     bugs.
   - Fix nocross opcode processing.
   - Fix several buffer over/under runs in
     lou_translateString.c:hyphenate.
   - Fix the '=' problem, i.e. fix inputPositions calculation for the
     case where the equals sign is used as the dots operand. Thanks to
     Bert Frees
   - Fix a bug when resizing a table. Previously not all references to
     this table were updated.

** Backwards incompatible changes
   - The feature that allowed a mapping between language code and
     Braille table was removed as it contained a out-of-bounds access
     bug, was never documented and probably never used. Thanks to
     Peter Nilsson Lundblad and Jeremy Roman for analyzing this
     problem and providing a patch.

* Noteworthy changes in release 2.5.2 (2012-12-18)

While initially planned as mainly a bug fix release this release
contains some notable new features: There is a new tool to trace which
rules have been used to perform a translation. Also along with other
new tables the long awaited table for UEB is finally here.

** New features
*** New tool to trace rule application
    There is a new tool (lou_trace) which helps to trace which rules
    have been used to perform a Braille translation. This is helpful
    for writing Braille tables. See the documentation for more
    information.
*** New Braille tables
    - Inuktitut grade 1, thanks to Greg Kearney.
    - UEB grade 1 and 2, thanks to Joseph Lee. These tables replace
      the old UEB tables (UEBC-g1.utb and UEBC-g2.ctb).
    - Korean table thanks to Joseph Lee

** Braille Table Improvements
   - da-dk-g2.ctb, fixes for transposed â, å, æ, ä, ø  and ö,
     corrected/improved harness tests.
   - Corrections for en-GB-g2.ctb thanks to Paul Wood
   - Corrections to the Hungarian grade 1 table thanks to Hammer
     Attila

** Bug Fixes
   - Update gnulib
   - Fix a bug in the correct opcode which causes sometimes random
     results when translating. Thanks to Bert Frees.
   - Fixes for compiler warnings.
   - Fix some Valgrind warnings about invalid reads
 
* Noteworthy changes in release 2.5.1 (2012-9-24)

** Braille Table Improvements
- Fix encoding problem in italian table and added more character
  definitions. Thanks to Simone Dal Maso <simone.dalmaso@juvox.it>.
- Rename it-it-g1.utb to it-it-comp6.utb and it-it-g1.utb2 to
  it-it-comp8.utb.

** Bug fixes
- Fix outputPos and inlen where an input character generates multiple
  output characters.

* Noteworthy changes in release 2.5.0 (2012-9-10)

This release contains a tremendous amount of work many developers.
Many long standing bugs have been fixed. The tables can finally be in
UTF-8. A grand table cleanup removed duplication from the tables.
There are now two extensive test frameworks for table writers. A
number of new tables have been contributed on top of the usual
assortment of table improvements. Thanks to all of this liblouis has
already seen quite a bit of uptake in a number of places, notably the
new DAISY pipeline will ship with this release of liblouis.

NOTE: If you have private tables you might want to migrate them to
utf-8. To do this just use iconv as follows:

  $ iconv -f latin-1 -t utf-8 <input >output

** New features
*** New Braille tables
    - Estonian grade 0, thanks to Jürgen Dengo.
    - Portuguese 8 dot Computer braille, Thanks to Rui Fontes
*** UTF-8 support in tables
    Braille tables can now contain UTF-8 in the opcode arguments.
*** Improvements to the python bindings
    All constants defined in liblouis.h are now exposed in the bindings.
*** Add a doctest infrastructure
    These tests are based on the Python doctest framework and are only
    run if there is a Python interpreter on the system
*** Add a test harness
    This test infrastructure allows the user to do table tests in a
    simple and concise syntax. These tests are based on the Python
    nose testing framework and are only run if either Python 2.x or
    3.x with the related nose python module is installed on the
    system. See the documentation for more information. Thanks to
    Mesar Hameed.
*** Add a test harness generator
    A harness generator that uses simple text files with a little
    formatting to help to generate the json harness files. The purpose
    of this tool is to make it much easier and faster to add checks
    for a given table. You are expected to read the generated harness
    file and make necessary changes, the tool only helps you to get
    the tests into the harness format, not check their validity.
*** Support for Python 3 in the Python bindings
    The Python bindings now work for both Python 2 and Python 3.
    Thanks to Michael Whapples.

** Improved C-based test framework
   - Improved the test framework to be able to test translations
     involving Unicode.
   - Added numerous tests, e.g. for lowercase and Unicode, for the
     input position, for repeated, etc.

** Improved the documentation
   - Document the test harness (json format, fields, flags).
   - Document the use of Valgrind to find memory leaks
   - Improve the documentation on the display opcode

** Bug fixes
   - lou_allround and lou_translate now properly handle Unicode
     characters
   - Fix some issues reported by Valgrind
   - Fix inputPos for situation where context and multipass opcodes
     are involved
   - Fixed a number of bugs with the letter, uppercase and lowercase
     opcodes when dealing with Unicode
   - Fixed a couple of bugs with hyphenation (documentation, Python
     bindings and a number of buffer overruns in the C library).
     Thanks Milan Zamazal <pdm@brailcom.org> for reporting this.
   - Fix a bug in the $a. matcher in the multipass rules where only 32
     chars were matched. It now matches 0xffff chars.
   - Fix a bug reported by James Teh related to pass1Only

** Braille Table Improvements
   - all table files have consistent encoding, UTF-8.
   - The grand table cleanup: Reorganize the tables to remove
     duplication. Move common parts such as Latin letter, eight and
     six dot digit definitions to separate files which are then
     included. This should ease table maintenance. Thanks to Mesar Hameed. 
   - Fixes to de-de-comp8.ctb thanks to Aliminator83@gmail.com
   - hu1.ctb renamed to hu-hu-g1.ctb
   - hu.ctb renamed to hu-hu-comp8.ctb
   - eo.ctb renamed to eo-g1.ctb
   - Fixes to eo-g1.ctb thanks to Aaron Cannon <cannona@fireantproductions.com>
   - hu-hu-g1.ctb: improvements and extensive test harness, with
     working back-translation, Thanks to Hammer Attila
   - Fixes to fr-bfu-comp6.utb and fr-bfu-comp8.utb thanks to Michel
     Such <michel.such@free.fr>
   - Reworked and extended Ethiopic braille table ethio-g1.ctb,
     superseeds gez*, thanks to Dr. Tamru E. Belay
     <g.braille@sympatico.ca>
   - Fixes to no-no-g3.ctb thanks to Lars Bjørndal <lars@lamasti.net>

* Noteworthy changes in release 2.4.1 (2012-2-22)

** New features
   - Czech hyphenation table thanks to Jan Hegr
   - Spanish grade 1 table provided by José Enrique Fernández del
     Campo and Juan Carlos Buño Suárez
   - New Tamil table thanks to Mesar Hameed

** Braille Table Improvements
   - Improvements to the Portuguese grade1 braille tables
   - Updates and additions to Icelandic 8-dot braille table.
   - Improvements to the uncontracted Spanish computer braille table.
   - Improvements to the Norwegian braille table thanks to David Hole.

* Noteworthy changes in release 2.4.0 (2012-01-31)

** New features
   - New Generic Farsi Grade 1 table: A new table for Generic Farsi
     Grade 1 braille has been provided by Mesar Hameed.
   - Emacs mode for editing Braille tables thanks to Christian Egli

** Braille Table Improvements
   - Improvements to the French comp6 and comp8 braille tables
   - Improvements to the Romanian braille table
   - Improvements to the Generic Arabic Grade 1 table
   - Improvements to the Czech tables thanks to Jan Halousek and to
     Jan Hegr

* Noteworthy changes in release 2.3.0 (2011-05-09)

This release contains support for many more languages than before
(Swedish, Kurdish, Ethiopic, Serbian, many Indian languages). The
search path for tables is now a list of paths. Finally there is the
usual assortment of bug fixes.

** New features
*** Multiple table search path
    The environment variable LOUIS_TABLEPATH can now contain a list of
    paths (separated by commas) where liblouis should look for tables.
    This allows the user to keep local tables.
*** New --quiet option for lou_checktable
    lou_checktable writes to stderr even in the case of success. This
    can now be suppressed with the new option --quiet.
*** New Swedish table
    A new table for Swedish braille has been provided by Samuel
    Thibault.
*** New table for Sorani (Kurdish)
    A new table for Sorani (Kurdish) Braille has been donated by Peter
    Engström from Index Braille
*** New table for Ethiopic
    A new table for Ethiopic Braille has been donated by Tamru E.
    Belay PH.D from Adaptive Technology Center for the Blind (ATCB)
*** New table for Serbian
    A new table for Serbian Braille has been donated by Peter Engström
    from Index Braille

** Improved the documentation
   The deprecated opcodes have been moved to a separate section

** Bug fixes
   - Fixed a long standing bug with an infinite loop in the table
     compiler

** Braille Table Improvements
   - Improvements to the Chinese braille table
   - Improvements to the Flemish Braille Math Code tables
   - Improvements to the Dutch	Braille tables
   - Improvements to the Spanish Braille tables.
   - Fixes for the uncontracted French 6 and 8 dot tables
   - Improved support for Italian 8 dot
   - Improvements to the Generic Arabic Grade 1 table

* Noteworthy changes in release 2.2.0 (????-??-??)

** New features
*** New tables
    - Support for many indian languages
    - Support for Icelandic 6- and 8-dot
    - Support for Catalan
    - Support for Dutch Braille (for Belgium and the Netherlands)
    - Support for Flemish Braille Math Code (a.k.a. Woluwe code)


*** New functions to make libraries relocatable
    Two new functions, to set the search path for tables and files.
    They make the library relocatable. See the in the documentation
    for lou_setDataPath and lou_getDataPath.

** Bug fixes
    - Improved support for Spanish
    - Improved Norwegian tables

* Noteworthy changes in release 2.1.1 (2010-8-23)

** Bug fixes
   - Fixed problems with the Danish grade 2 table
   - Fixed problems with the Marburg maths table for mathematics and
     the UK maths table for mathematics

* Noteworthy changes in release 2.1.0 (2010-8-19)

** New features
*** New tables
    - Added tables for Portuguese grade 1 and 2
    - Added unicode.dis for Unicode braille
*** Modified tables
    - Updated Danish tables
*** Implemented language to table mapping
*** New format of error messages
    The error messages are now reported in a format similar to the one
    used in gcc. 
*** New opcode
    - added undefined opcode
*** Python bindings
    - Allow the user to configure the maximum output length by
      specifying a number by which the input length is multiplied
      using the outlenMultiplier module variable. The default will
      handle the case where every input character is undefined in the
      translation table. Previously, this was hard-coded to 2, which
      was insufficient in some cases.
    - Add compbrlLeftCursor mode constant.
    - Add compileString function which wraps lou_compileString.
    - Corrections/clarifications to docstrings.
    - Add python binding for the lou_hyphenate function.
    - Added python wrapper for lou_backTranslateString and lou_backTranslate.

*** liblouisxslt as an example
    Add liblouisxslt as an example to python/examples. This is
    basically an extension of libxslt that lets you invoke liblouis
    from an xslt stylesheet to do Braille translation on text nodes
    for example. 
*** compbrlLeftCursor
    Added a patch provided by Volker Bijewitz to implement
    compbrlLeftCursor.

** Bug fixes
*** output cursorPos
    Fix the output cursorPos when the compbrlAtCursor mode is enabled
    and the characters around the cursor translate to multiple braille
    cells, such as in the Chinese braille tables.
*** outpos when doing back translation
    Include a patch by Timothy Lee to fix outpos when doing back translation
      (issue 11)
*** inputPos/outputPos for undefined characters
    Fix the input/output position arrays for characters in the input
      which are undefined in the translation table.
*** table fixes
    - Fixed a bug with back translation of '*n'. (issue 13)
    - Fixes to the en-us-g2.ctb table
*** Python bindings
    - Remove unnecessary imports, allowing the bindings to run in Python
      2.7. (issue 12)
    - lou_translate* writes output information in typeform, so
      allocate enough bytes for it. Fixes possible buffer overruns and
      resultant crashes.
*** Miscellaneous
    - Fixes to the man page generation to fix issues that were
      reported by the Debian packaging builder
    - Do not invoke help2man when cross-compiling 
    - Documentation updates (issue 10)
    - Removing noletsign defaults
    - Many small fixes

* Noteworthy changes in release 2.0.0 (2010-7-6)

** New features
*** New functions
    - Adding lou_charSize function

* Noteworthy changes in release 1.9.0 (2010-6-29)

** New features
*** New functions
    - lou_dotsToChar and lou_charToDots function
    - Added lou_compileString for adding entries to tables at
      run-time.

* Noteworthy changes in release 1.8.0 (2009-11-23)

This release contains a number of improvements notably the integration
of gnulib, the automatic generation of man pages and the addition of
tables for German grade 2.

** New features
*** New tables
    - Tables German Grade 2
    - Swiss German
    - Swedish (1989 standard)
    - Swedish (1996 standard)

*** Modified tables
    - Updated Norwegian tables
    - Updated Chinese braille table

*** man pages
    All tools accept the --version and --help options and are
    documented in man pages

*** Corpus based test cases for tables
    You can now have corpus based tests for tables. See the README in
    tests/table_test_corpuses.

** Bug fixes
   - config.h is no longer exported
   - Many small fixes

* Noteworthy changes in release 1.7.0 (2009-08-21)

The main new feature of this release is the support for UK and Marburg
math. Other changes include a new tool to check hyphenation and the
usual improvement and addition of tables. Also The test suite has been
enhanced and finally passes.

** New features
*** New tables
    - Tables for UK and Marburg math
    - Hong Kong Cantonese
    - Hebrew
    - Hungarian
    - Slovene
    - Tibetan
    - Irish
    - Maltese

*** Modified tables
    - Updated Norwegian tables
    - Bug fixes in Russian tables
    - Updated French tables

*** lou_checkhyphens tool
    New tool to check hyphenation
*** rpm spec file
*** Test cases for tables
    The tables can now be tested with `make check'
*** New opcodes
    - noback and nofor opcode prefixes
    - grouping opcode
    - multipass subopcodes

** Bug fixes
   - Fix for library name and Python bindings
   - Documentation fixes
   - Many small fixes

* Noteworthy changes in release 1.6.2 (2009-05-01)

This release contains a new opcode for Malaysian Braille. See the
documentation for a description of the new opcode.

** New features

*** repword opcode 
The repword opcode is needed for Malaysian Braille

* Noteworthy changes in release 1.6.1 (2009-04-21)

This is mostly a bug fix release. It contains many bug fixes that were
discovered in the course of developing UK Math tables.

** Bug fixes

*** bug fixes for correct, context and multipass opcodes
*** bug fixes for largesign opcode
*** fixed bug with French back-translation
*** fixed the installation path for docs
*** documentation improvement

* Noteworthy changes in release 1.6 (2009-03-04)

This release features support for Danish and Russian and updated
tables for French and Norwegian. The search path for tables can now be
specified using an environment variable. Finally there is the usual
assortment of bug fixes.

** New features

*** exactdots opcode
The exactdots opcode is intended for use in liblouisxml
semantic-action files to specify exact dot patterns, as in
mathematical codes.
*** LOUIS_TABLEPATH env variable
You can now specify where liblouis is to look for tables with the
LOUIS_TABLEPATH environment variable.
*** New Tables for Danish and Russian
There is now support for Danish and Russian.

** Bug fixes

*** Updated French and Norwegian tables
*** Use stdcall calling convention if building for Windows

** Changes in behavior

None

* Noteworthy changes in release 1.5 (2009-01-21)

This is a big release for liblouis. It's the first time that it is
done from the Google code page. A number of people have contributed,
namely John Boyer (table debugger, bug fixes), Eitan Isaacson (Python
bindings), James Teh (Python bindings, bug fixes), Christian Egli
(documentation) and Michel Such (table for French grade 2).


** New features

*** Python bindings
The liblouis library can now be used from Python. For more info
consult the README file in the python directory.

*** Table debugger
liblouis now comes with a debugger that can help to find problems with
translation tables.

*** French table for grade 2
There is now a translation table for French grade 2.

*** pass1Only mode bit
The new pass1Only mode bit will help developers of screen readers as
the cursor will stay where it is expected to.

** Bug fixes

Fix the inpos array values for the case where a rule has an output
length which is larger than its input length.

fixed multi-word phrases

fixed bug in character display

fixed bug in findOpcodeName

lou_version now returns the correct liblouis version

** Changes in behavior

None

* COMMENT Noteworthy changes in release 3.XX.0 (202X-XX-XX)        :Template:
I'd like to thank everybody for helping to bring liblouis forward.

For a detailed list of all the changes refer to [[https://github.com/liblouis/liblouis/milestone/26?closed=1][the list of closed
issues]].

** New features
** Bug fixes
** Braille table improvements
** Other changes
** Deprecation notice
- None
** Backwards incompatible changes
** Invisible changes
** New, renamed or removed tables
*** New
- None

*** Renamed
- None

*** Removed
- None

#+OPTIONS: toc:nil num:nil
